export { atomTable, AtomTable } from "./snippets/gui_web-fe567f277be011de/js/utils";
import { atomTable } from "./snippets/gui_web-fe567f277be011de/js/utils";
import { murmurhash3_32s } from "pi_tools/hash";

/**
 * 获取atom的number， 用于将字符串数字化
 * 一些静态字符串，底层不关心字符串的具体值，通常是选择一个数字进行高层和底层的通信
 * @param v 
 * @returns 
 */
export function getAtomnumber(v: number | string): number {
	if (typeof v === "number") {
		return v;
	} else {
		let number = atomTable.get_number(v)
		if (!number) {
			number = murmurhash3_32s(v, 0);
			atomTable.set(number, v);
		}
		return number;
	}
}

/**
 * 获取atom的key， 用于将字符串数字化
 * 一些静态字符串，底层不关心字符串的具体值，通常是选择一个数字进行高层和底层的通信
 * @param v 
 * @returns 
 */
export function getAtom(v: number | string): [number, string] {
	if (typeof v === "number") {
		let r = atomTable.get_string(v);
		if (!r) {
			throw new Error("No string found！！！， hash:" + v);
		}
		return [v, r];
	} else {
		return [getAtomnumber(v), v];
	}
}