import { fillBackGround, setFont, drawCharWithStroke, drawChar, drawSdf, setSdfSuccessCallback, measureText, loadImage } from './snippets/gui_web-fe567f277be011de/js/utils';
import { bon_buffer } from './snippets/pi_bon_decode-e37c4badad99c9d8/src/bon_buffer';
import { path_result, round_result } from './snippets/pi_path_finding-5adffefcd0cb3062/src/web/path_result';
import { writeLog } from './snippets/pi_web_logger-549b001d22d1ba4e/js/utils';
import { destroy_res } from './snippets/res_mgr_web-2b25513b6ef19496/js/res_utils';
import * as __wbg_star0 from './snippets/gui_web-fe567f277be011de/js/utils';

let wasm;

const heap = new Array(128).fill(undefined);

heap.push(undefined, null, true, false);

function getObject(idx) { return heap[idx]; }

let heap_next = heap.length;

function dropObject(idx) {
    if (idx < 132) return;
    heap[idx] = heap_next;
    heap_next = idx;
}

function takeObject(idx) {
    const ret = getObject(idx);
    dropObject(idx);
    return ret;
}

const cachedTextDecoder = (typeof TextDecoder !== 'undefined' ? new TextDecoder('utf-8', { ignoreBOM: true, fatal: true }) : { decode: () => { throw Error('TextDecoder not available') } } );

if (typeof TextDecoder !== 'undefined') { cachedTextDecoder.decode(); };

let cachedUint8ArrayMemory0 = null;

function getUint8ArrayMemory0() {
    if (cachedUint8ArrayMemory0 === null || cachedUint8ArrayMemory0.byteLength === 0) {
        cachedUint8ArrayMemory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8ArrayMemory0;
}

function getStringFromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return cachedTextDecoder.decode(getUint8ArrayMemory0().subarray(ptr, ptr + len));
}

function addHeapObject(obj) {
    if (heap_next === heap.length) heap.push(heap.length + 1);
    const idx = heap_next;
    heap_next = heap[idx];

    heap[idx] = obj;
    return idx;
}

function isLikeNone(x) {
    return x === undefined || x === null;
}

let cachedDataViewMemory0 = null;

function getDataViewMemory0() {
    if (cachedDataViewMemory0 === null || cachedDataViewMemory0.buffer.detached === true || (cachedDataViewMemory0.buffer.detached === undefined && cachedDataViewMemory0.buffer !== wasm.memory.buffer)) {
        cachedDataViewMemory0 = new DataView(wasm.memory.buffer);
    }
    return cachedDataViewMemory0;
}

let WASM_VECTOR_LEN = 0;

const cachedTextEncoder = (typeof TextEncoder !== 'undefined' ? new TextEncoder('utf-8') : { encode: () => { throw Error('TextEncoder not available') } } );

const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
    ? function (arg, view) {
    return cachedTextEncoder.encodeInto(arg, view);
}
    : function (arg, view) {
    const buf = cachedTextEncoder.encode(arg);
    view.set(buf);
    return {
        read: arg.length,
        written: buf.length
    };
});

function passStringToWasm0(arg, malloc, realloc) {

    if (realloc === undefined) {
        const buf = cachedTextEncoder.encode(arg);
        const ptr = malloc(buf.length, 1) >>> 0;
        getUint8ArrayMemory0().subarray(ptr, ptr + buf.length).set(buf);
        WASM_VECTOR_LEN = buf.length;
        return ptr;
    }

    let len = arg.length;
    let ptr = malloc(len, 1) >>> 0;

    const mem = getUint8ArrayMemory0();

    let offset = 0;

    for (; offset < len; offset++) {
        const code = arg.charCodeAt(offset);
        if (code > 0x7F) break;
        mem[ptr + offset] = code;
    }

    if (offset !== len) {
        if (offset !== 0) {
            arg = arg.slice(offset);
        }
        ptr = realloc(ptr, len, len = offset + arg.length * 3, 1) >>> 0;
        const view = getUint8ArrayMemory0().subarray(ptr + offset, ptr + len);
        const ret = encodeString(arg, view);

        offset += ret.written;
        ptr = realloc(ptr, len, offset, 1) >>> 0;
    }

    WASM_VECTOR_LEN = offset;
    return ptr;
}

function getArrayU8FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getUint8ArrayMemory0().subarray(ptr / 1, ptr / 1 + len);
}

function debugString(val) {
    // primitive types
    const type = typeof val;
    if (type == 'number' || type == 'boolean' || val == null) {
        return  `${val}`;
    }
    if (type == 'string') {
        return `"${val}"`;
    }
    if (type == 'symbol') {
        const description = val.description;
        if (description == null) {
            return 'Symbol';
        } else {
            return `Symbol(${description})`;
        }
    }
    if (type == 'function') {
        const name = val.name;
        if (typeof name == 'string' && name.length > 0) {
            return `Function(${name})`;
        } else {
            return 'Function';
        }
    }
    // objects
    if (Array.isArray(val)) {
        const length = val.length;
        let debug = '[';
        if (length > 0) {
            debug += debugString(val[0]);
        }
        for(let i = 1; i < length; i++) {
            debug += ', ' + debugString(val[i]);
        }
        debug += ']';
        return debug;
    }
    // Test for built-in
    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
    let className;
    if (builtInMatches.length > 1) {
        className = builtInMatches[1];
    } else {
        // Failed to match the standard '[object ClassName]'
        return toString.call(val);
    }
    if (className == 'Object') {
        // we're a user defined class or Object
        // JSON.stringify avoids problems with cycles, and is generally much
        // easier than looping through ownProperties of `val`.
        try {
            return 'Object(' + JSON.stringify(val) + ')';
        } catch (_) {
            return 'Object';
        }
    }
    // errors
    if (val instanceof Error) {
        return `${val.name}: ${val.message}\n${val.stack}`;
    }
    // TODO we could test for more things here, like `Set`s and `Map`s.
    return className;
}

const CLOSURE_DTORS = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(state => {
    wasm.__wbindgen_export_2.get(state.dtor)(state.a, state.b)
});

function makeMutClosure(arg0, arg1, dtor, f) {
    const state = { a: arg0, b: arg1, cnt: 1, dtor };
    const real = (...args) => {
        // First up with a closure we increment the internal reference
        // count. This ensures that the Rust closure environment won't
        // be deallocated while we're invoking it.
        state.cnt++;
        const a = state.a;
        state.a = 0;
        try {
            return f(a, state.b, ...args);
        } finally {
            if (--state.cnt === 0) {
                wasm.__wbindgen_export_2.get(state.dtor)(a, state.b);
                CLOSURE_DTORS.unregister(state);
            } else {
                state.a = a;
            }
        }
    };
    real.original = state;
    CLOSURE_DTORS.register(real, state, state);
    return real;
}
function __wbg_adapter_38(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
    wasm._dyn_core__ops__function__FnMut__A_B_C_D_E_F___Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h3b6f8a1110c930d4(arg0, arg1, arg2, arg3, arg4, arg5, arg6, addHeapObject(arg7));
}

function __wbg_adapter_41(arg0, arg1, arg2) {
    wasm._dyn_core__ops__function__FnMut__A____Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h3f5b8604047fff8f(arg0, arg1, addHeapObject(arg2));
}

function __wbg_adapter_44(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) {
    wasm._dyn_core__ops__function__FnMut__A_B_C_D_E_F_G_H___Output___R_as_wasm_bindgen__closure__WasmClosure___describe__invoke__h512ae9f6de7c0661(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, addHeapObject(arg8), arg9);
}

/**
* @param {Level} level
*/
export function init_logger(level) {
    wasm.init_logger(level);
}

/**
* 在指定上下文中创建一个 文本样式表
*__jsObj: class样式的文本描述
* @param {number} world
* @param {number} class_id
* @param {string} css
*/
export function create_class(world, class_id, css) {
    const ptr0 = passStringToWasm0(css, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.create_class(world, class_id, ptr0, len0);
}

function passArray8ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 1, 1) >>> 0;
    getUint8ArrayMemory0().set(arg, ptr / 1);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* 添加二进制格式的css表
* @param {number} world
* @param {Uint8Array} bin
*/
export function create_class_by_bin(world, bin) {
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.create_class_by_bin(world, ptr0, len0);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_align_content(world, node_id, value) {
    wasm.set_align_content(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_align_items(world, node_id, value) {
    wasm.set_align_items(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_justify_content(world, node_id, value) {
    wasm.set_justify_content(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_flex_direction(world, node_id, value) {
    wasm.set_flex_direction(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_flex_wrap(world, node_id, value) {
    wasm.set_flex_wrap(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_align_self(world, node_id, value) {
    wasm.set_align_self(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_position_type(world, node_id, value) {
    wasm.set_position_type(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_flex_grow(world, node_id, value) {
    wasm.set_flex_grow(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_flex_shrink(world, node_id, value) {
    wasm.set_flex_shrink(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_width(world, node_id, value) {
    wasm.set_width(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_height(world, node_id, value) {
    wasm.set_height(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_min_width(world, node_id, value) {
    wasm.set_min_width(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_min_height(world, node_id, value) {
    wasm.set_min_height(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_max_width(world, node_id, value) {
    wasm.set_max_width(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_max_height(world, node_id, value) {
    wasm.set_max_height(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_width_percent(world, node_id, value) {
    wasm.set_width_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_height_percent(world, node_id, value) {
    wasm.set_height_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_min_width_percent(world, node_id, value) {
    wasm.set_min_width_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_min_height_percent(world, node_id, value) {
    wasm.set_min_height_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_max_width_percent(world, node_id, value) {
    wasm.set_max_width_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_max_height_percent(world, node_id, value) {
    wasm.set_max_height_percent(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function set_width_auto(world, node_id) {
    wasm.set_width_auto(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function set_height_auto(world, node_id) {
    wasm.set_height_auto(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_padding(world, node_id, edge, value) {
    wasm.set_padding(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_margin(world, node_id, edge, value) {
    wasm.set_margin(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_border(world, node_id, edge, value) {
    wasm.set_border(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_position(world, node_id, edge, value) {
    wasm.set_position(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_padding_percent(world, node_id, edge, value) {
    wasm.set_padding_percent(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_margin_percent(world, node_id, edge, value) {
    wasm.set_margin_percent(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
* @param {number} value
*/
export function set_position_percent(world, node_id, edge, value) {
    wasm.set_position_percent(world, node_id, edge, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} edge
*/
export function set_margin_auto(world, node_id, edge) {
    wasm.set_margin_auto(world, node_id, edge);
}

/**
* 创建容器节点， 容器节点可设置背景颜色
* @param {number} world
* @returns {number}
*/
export function create_node(world) {
    const ret = wasm.create_canvas_node(world);
    return ret >>> 0;
}

/**
* 创建虚拟节点
* @param {number} world
* @returns {number}
*/
export function create_vnode(world) {
    const ret = wasm.create_vnode(world);
    return ret >>> 0;
}

/**
* 节点是否存在
* @param {number} world
* @param {number} node
* @returns {boolean}
*/
export function node_is_exist(world, node) {
    const ret = wasm.node_is_exist(world, node);
    return ret !== 0;
}

/**
* @param {number} world
* @param {number} node
* @returns {boolean}
*/
export function node_is_visibility(world, node) {
    const ret = wasm.node_is_visibility(world, node);
    return ret !== 0;
}

/**
* 创建文本节点
* @param {number} world
* @returns {number}
*/
export function create_text_node(world) {
    const ret = wasm.create_text_node(world);
    return ret >>> 0;
}

/**
* 创建图片节点
* @param {number} world
* @returns {number}
*/
export function create_image_node(world) {
    const ret = wasm.create_canvas_node(world);
    return ret >>> 0;
}

/**
* 创建图片节点
* @param {number} world
* @returns {number}
*/
export function create_canvas_node(world) {
    const ret = wasm.create_canvas_node(world);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} texture
* @returns {WebGLTexture}
*/
export function get_webgl_texture(world, texture) {
    const ret = wasm.get_webgl_texture(world, texture);
    return takeObject(ret);
}

/**
*
* * canvas宽高改变时调用(分配纹理成功，返回对应索引，否则返回-1)
* * @return __jsObj 纹理
* @param {number} world
* @param {number} node
* @param {number} width
* @param {number} height
* @param {number} soruce
* @param {boolean} need_depth
* @returns {number}
*/
export function set_canvas_size(world, node, width, height, soruce, need_depth) {
    const ret = wasm.set_canvas_size(world, node, width, height, soruce, need_depth);
    return ret;
}

/**
* 设置图片数据为一个fbo
* @param {number} world
* @param {number} node
* @param {number} soruce
* @param {number} index
*/
export function set_data_image_fbo(world, node, soruce, index) {
    wasm.set_data_image_fbo(world, node, soruce, index);
}

/**
* 设置图片为一个内存图片
* @param {number} world_id
* @param {number} node
* @param {number} name
* @param {number} pformate
* @param {HTMLImageElement} data
*/
export function set_data_image_image(world_id, node, name, pformate, data) {
    wasm.set_data_image_image(world_id, node, name, pformate, addHeapObject(data));
}

/**
* @param {number} world
* @param {number} index
* @returns {any}
*/
export function get_canvas_rect(world, index) {
    const ret = wasm.get_canvas_rect(world, index);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} index
* @returns {WebGLFramebuffer | undefined}
*/
export function get_canvas_target(world, index) {
    const ret = wasm.get_canvas_target(world, index);
    return takeObject(ret);
}

/**
*
* * canvas内容发生改变时，应该调用此方法更新gui渲染
* @param {number} world
* @param {number} _node
*/
export function update_canvas(world, _node) {
    wasm.update_canvas(world, _node);
}

/**
* 在尾部插入子节点，如果该节点已经存在父节点， 会移除原有父节点对本节点的引用
* @param {number} world
* @param {number} child
* @param {number} parent
*/
export function append_child(world, child, parent) {
    wasm.append_child(world, child, parent);
}

/**
* 在某个节点之前插入节点，如果该节点已经存在父节点， 会移除原有父节点对本节点的引用
* @param {number} world
* @param {number} child
* @param {number} brother
*/
export function insert_before(world, child, brother) {
    wasm.insert_before(world, child, brother);
}

/**
* 移除节点， 但不会销毁， 如果节点树中存在图片资源， 将会释放其对纹理的引用， 如果节点树中overflow=hidden， 将会删除对应的裁剪平面，
* @param {number} world
* @param {number} node_id
*/
export function remove_node(world, node_id) {
    wasm.remove_node(world, node_id);
}

/**
* @param {number} world
* @param {number} parent
* @returns {number}
*/
export function first_child(world, parent) {
    const ret = wasm.first_child(world, parent);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} parent
* @returns {number}
*/
export function last_child(world, parent) {
    const ret = wasm.last_child(world, parent);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function next_sibling(world, node) {
    const ret = wasm.next_sibling(world, node);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function previous_sibling(world, node) {
    const ret = wasm.previous_sibling(world, node);
    return ret >>> 0;
}

/**
* 返回节点的层级（如果节点未添加在根上，返回0, 不存在节点，返回0）
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function get_layer(world, node) {
    const ret = wasm.get_layer(world, node);
    return ret >>> 0;
}

/**
* 销毁节点
* @param {number} world
* @param {number} node_id
*/
export function destroy_node(world, node_id) {
    wasm.destroy_node(world, node_id);
}

/**
* __jsObj: image_name(String)
* 设置图片的src
* @param {number} world
* @param {number} node
* @param {number} url
*/
export function set_src(world, node, url) {
    wasm.set_src(world, node, url);
}

/**
* 返回值原类型为f32,这里之所以返回u32，是因为在iphonex以上的机型的浏览器上多次连续调用返回值为浮点数时，浏览器会自动刷新或白屏，原因未知
* 节点到gui的上边界的距离
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function offset_top(world, node) {
    const ret = wasm.offset_top(world, node);
    return ret;
}

/**
* 返回值原类型为f32,这里之所以返回u32，是因为在iphonex以上的机型的浏览器上多次连续调用返回值为浮点数时，浏览器会自动刷新或白屏，原因未知
* 节点到gui的左边界的距离
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function offset_left(world, node) {
    const ret = wasm.offset_left(world, node);
    return ret;
}

/**
* 返回值原类型为f32,这里之所以返回u32，是因为在iphonex以上的机型的浏览器上多次连续调用返回值为浮点数时，浏览器会自动刷新或白屏，原因未知
* 节点的布局宽度
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function offset_width(world, node) {
    const ret = wasm.offset_width(world, node);
    return ret;
}

/**
* 返回值原类型为f32,这里之所以返回u32，是因为在iphonex以上的机型的浏览器上多次连续调用返回值为浮点数时，浏览器会自动刷新或白屏，原因未知
* 节点布局高度
* @param {number} world
* @param {number} node
* @returns {number}
*/
export function offset_height(world, node) {
    const ret = wasm.offset_height(world, node);
    return ret;
}

/**
* 等同于html的getBoundingClientRect
* left top width height
* @param {number} world
* @param {number} node_id
* @returns {any}
*/
export function offset_document(world, node_id) {
    const ret = wasm.offset_document(world, node_id);
    return takeObject(ret);
}

/**
* content宽高的累加值
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function content_box(world, node) {
    const ret = wasm.content_box(world, node);
    return takeObject(ret);
}

/**
* 用点命中一个节点
* @param {number} world
* @param {number} x
* @param {number} y
* @returns {number}
*/
export function query(world, x, y) {
    const ret = wasm.query(world, x, y);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} node
* @param {number} x
* @param {number} y
* @returns {any}
*/
export function query_text(world, node, x, y) {
    const ret = wasm.query_text(world, node, x, y);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} node
* @param {number} index
* @returns {any}
*/
export function get_text_pos(world, node, index) {
    const ret = wasm.get_text_pos(world, node, index);
    return takeObject(ret);
}

/**
* 判断点是否能命中点
* @param {number} world
* @param {number} x
* @param {number} y
* @param {number} node
* @returns {boolean}
*/
export function is_intersect(world, x, y, node) {
    const ret = wasm.is_intersect(world, x, y, node);
    return ret !== 0;
}

/**
* @param {number} world
* @param {number} x
* @param {number} y
* @returns {number}
*/
export function iter_query(world, x, y) {
    const ret = wasm.iter_query(world, x, y);
    return ret >>> 0;
}

/**
* @param {number} world_id
* @param {number} node_id
* @param {number} key
* @param {number} index
*/
export function add_class(world_id, node_id, key, index) {
    wasm.add_class(world_id, node_id, key, index);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} old
*/
export function add_class_end(world, node_id, old) {
    wasm.add_class_end(world, node_id, old);
}

/**
* @param {number} world
* @param {number} node_id
* @returns {number}
*/
export function add_class_start(world, node_id) {
    const ret = wasm.add_class_start(world, node_id);
    return ret >>> 0;
}

let cachedUint32ArrayMemory0 = null;

function getUint32ArrayMemory0() {
    if (cachedUint32ArrayMemory0 === null || cachedUint32ArrayMemory0.byteLength === 0) {
        cachedUint32ArrayMemory0 = new Uint32Array(wasm.memory.buffer);
    }
    return cachedUint32ArrayMemory0;
}

function passArray32ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 4, 4) >>> 0;
    getUint32ArrayMemory0().set(arg, ptr / 4);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* @param {number} world_id
* @param {number} node_id
* @param {Uint32Array} class_names
*/
export function set_class(world_id, node_id, class_names) {
    const ptr0 = passArray32ToWasm0(class_names, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_class(world_id, node_id, ptr0, len0);
}

/**
* 设置背景色的rgba
* @param {number} world
* @param {number} node
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_background_rgba_color(world, node, r, g, b, a) {
    wasm.set_background_rgba_color(world, node, r, g, b, a);
}

let cachedFloat32ArrayMemory0 = null;

function getFloat32ArrayMemory0() {
    if (cachedFloat32ArrayMemory0 === null || cachedFloat32ArrayMemory0.byteLength === 0) {
        cachedFloat32ArrayMemory0 = new Float32Array(wasm.memory.buffer);
    }
    return cachedFloat32ArrayMemory0;
}

function passArrayF32ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 4, 4) >>> 0;
    getFloat32ArrayMemory0().set(arg, ptr / 4);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}
/**
* 设置一个线性渐变的背景颜色
* @param {number} world
* @param {number} node
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_background_linear_gradient_color(world, node, direction, color_and_positions) {
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_background_linear_gradient_color(world, node, direction, ptr0, len0);
}

/**
* 设置边框颜色， 类型为rgba
* @param {number} world
* @param {number} node
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_border_color(world, node, r, g, b, a) {
    wasm.set_border_color(world, node, r, g, b, a);
}

/**
* 设置边框圆角
* @param {number} world
* @param {number} node
* @param {string} value
*/
export function set_border_radius(world, node, value) {
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_border_radius(world, node, ptr0, len0);
}

/**
* 设置clip_path
* @param {number} world
* @param {number} node
* @param {string} value
*/
export function set_clip_path_str(world, node, value) {
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_clip_path_str(world, node, ptr0, len0);
}

function _assertClass(instance, klass) {
    if (!(instance instanceof klass)) {
        throw new Error(`expected instance of ${klass.name}`);
    }
    return instance.ptr;
}
/**
* 设置clip_path
* @param {number} world
* @param {number} node
* @param {BaseShape1} value
*/
export function set_clip_path(world, node, value) {
    _assertClass(value, BaseShape1);
    wasm.set_clip_path(world, node, value.__wbg_ptr);
}

/**
* 对clip属性进行插值
* @param {BaseShape1} value1
* @param {BaseShape1} value2
* @param {number} process
* @returns {BaseShape1}
*/
export function interpolation_clip_path(value1, value2, process) {
    _assertClass(value1, BaseShape1);
    _assertClass(value2, BaseShape1);
    const ret = wasm.interpolation_clip_path(value1.__wbg_ptr, value2.__wbg_ptr, process);
    return BaseShape1.__wrap(ret);
}

/**
* 创建baseshape
* @param {string} value
* @returns {BaseShape1 | undefined}
*/
export function create_base_shape(value) {
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.create_base_shape(ptr0, len0);
    return ret === 0 ? null : BaseShape1.__wrap(ret);
}

/**
* 设置阴影v
* @param {number} world
* @param {number} node
* @param {number} h
* @param {number} v
* @param {number} blur
* @param {number} spread
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_box_shadow(world, node, h, v, blur, spread, r, g, b, a) {
    wasm.set_box_shadow(world, node, h, v, blur, spread, r, g, b, a);
}

/**
* 设置object_fit
* @param {number} world
* @param {number} node
* @param {number} value
*/
export function set_object_fit(world, node, value) {
    wasm.set_object_fit(world, node, value);
}

/**
* @param {number} world
* @param {number} node
* @param {number} x
* @param {number} y
*/
export function set_background_repeat(world, node, x, y) {
    wasm.set_background_repeat(world, node, x, y);
}

/**
* @param {number} world
* @param {number} node
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_image_clip(world, node, u1, v1, u2, v2) {
    wasm.set_image_clip(world, node, u1, v1, u2, v2);
}

/**
* @param {number} world
* @param {number} node
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_mask_image_clip(world, node, u1, v1, u2, v2) {
    wasm.set_mask_image_clip(world, node, u1, v1, u2, v2);
}

/**
* @param {number} world
* @param {number} node
* @param {number} u1
* @param {number} v1
* @param {number} u2
* @param {number} v2
*/
export function set_border_image_clip(world, node, u1, v1, u2, v2) {
    wasm.set_border_image_clip(world, node, u1, v1, u2, v2);
}

/**
* 设置border_image_slice
* @param {number} world
* @param {number} node
* @param {number} top
* @param {number} right
* @param {number} bottom
* @param {number} left
* @param {boolean} fill
*/
export function set_border_image_slice(world, node, top, right, bottom, left, fill) {
    wasm.set_border_image_slice(world, node, top, right, bottom, left, fill);
}

/**
* 设置border_image_slice
* @param {number} world
* @param {number} node
* @param {number} vertical
* @param {number} horizontal
*/
export function set_border_image_repeat(world, node, vertical, horizontal) {
    wasm.set_border_image_repeat(world, node, vertical, horizontal);
}

/**
* 设置overflow
* @param {number} world
* @param {number} node
* @param {boolean} value
*/
export function set_overflow(world, node, value) {
    wasm.set_overflow(world, node, value);
}

/**
* 设置不透明度
* @param {number} world
* @param {number} node
* @param {number} value
*/
export function set_opacity(world, node, value) {
    wasm.set_opacity(world, node, value);
}

/**
* 设置display
* @param {number} world
* @param {number} node
* @param {number} value
*/
export function set_display(world, node, value) {
    wasm.set_display(world, node, value);
}

/**
* 设置visibility, true: visible, false: hidden,	默认true
* @param {number} world
* @param {number} node
* @param {boolean} value
*/
export function set_visibility(world, node, value) {
    wasm.set_visibility(world, node, value);
}

/**
* 设置enable
* @param {number} world
* @param {number} node
* @param {number} value
*/
export function set_enable(world, node, value) {
    wasm.set_enable(world, node, value);
}

/**
* 取enable
* @param {number} world
* @param {number} node
* @returns {boolean}
*/
export function get_enable(world, node) {
    const ret = wasm.get_enable(world, node);
    return ret !== 0;
}

/**
* 这只z_index
* @param {number} world
* @param {number} node
* @param {number} value
*/
export function set_zindex(world, node, value) {
    wasm.set_zindex(world, node, value);
}

/**
* @param {number} world
* @param {number} node
* @param {number} blur
*/
export function set_filter_blur(world, node, blur) {
    wasm.set_filter_blur(world, node, blur);
}

/**
* hsi, 效果与ps一致,  h: -180 ~ 180, s: -100 ~ 100, i: -100 ~ 100
* @param {number} world
* @param {number} node
* @param {number} h
* @param {number} s
* @param {number} i
*/
export function set_filter_hsi(world, node, h, s, i) {
    wasm.set_filter_hsi(world, node, h, s, i);
}

/**
* __jsObj: image_name(String)
* @param {number} world
* @param {number} node
* @param {number} url
*/
export function set_border_image(world, node, url) {
    wasm.set_border_image(world, node, url);
}

/**
* __jsObj: image_name(String)
* @param {number} world
* @param {number} node
* @param {number} url
*/
export function set_mask_image(world, node, url) {
    wasm.set_mask_image(world, node, url);
}

/**
* @param {number} world
* @param {number} node
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_mask_image_linenear(world, node, direction, color_and_positions) {
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_mask_image_linenear(world, node, direction, ptr0, len0);
}

/**
* @param {number} world
* @param {number} node
* @param {number} blend_mode
*/
export function set_blend_mode(world, node, blend_mode) {
    wasm.set_blend_mode(world, node, blend_mode);
}

/**
* 设置默认样式, 暂支持布局属性、 文本属性的设置
* __jsObj: class样式的二进制描述， 如".0{color:red}"生成的二进制， class名称必须是“0”
* @param {number} world
* @param {string} value
*/
export function set_default_style_by_str(world, value) {
    const ptr0 = passStringToWasm0(value, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_default_style_by_str(world, ptr0, len0);
}

/**
* @param {number} world
* @param {Uint8Array} bin
*/
export function set_default_style_by_bin(world, bin) {
    const ptr0 = passArray8ToWasm0(bin, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_default_style_by_bin(world, ptr0, len0);
}

/**
* 设置默认样式, 暂支持布局属性、 文本属性的设置
* __jsObj: class样式的文本描述
* @param {number} world
* @param {string} css
*/
export function set_default_style(world, css) {
    const ptr0 = passStringToWasm0(css, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_default_style(world, ptr0, len0);
}

/**
* 设置transform_will_change
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_transform_will_change(world, node_id, value) {
    wasm.set_transform_will_change(world, node_id, value);
}

/**
* @param {number} world
* @returns {any}
*/
export function list_class(world) {
    const ret = wasm.list_class(world);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function get_layout(world, node) {
    const ret = wasm.get_layout(world, node);
    return takeObject(ret);
}

/**
*/
export function test_insert() {
    wasm.test_insert();
}

/**
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function get_class_name(world, node) {
    const ret = wasm.get_class_name(world, node);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} class_name
* @returns {any}
*/
export function get_class(world, class_name) {
    const ret = wasm.get_class(world, class_name);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function node_info(world, node) {
    const ret = wasm.node_info(world, node);
    return takeObject(ret);
}

/**
* @param {number} world
* @returns {any}
*/
export function overflow_clip(world) {
    const ret = wasm.overflow_clip(world);
    return takeObject(ret);
}

/**
* @param {number} world
* @returns {any}
*/
export function res_size(world) {
    const ret = wasm.res_size(world);
    return takeObject(ret);
}

/**
* 列出现有的纹理资源
* @param {number} world
* @returns {any}
*/
export function list_texture(world) {
    const ret = wasm.list_texture(world);
    return takeObject(ret);
}

/**
* @param {number} world
* @returns {any}
*/
export function list_fbo(world) {
    const ret = wasm.list_fbo(world);
    return takeObject(ret);
}

/**
* @param {number} world
* @returns {any}
*/
export function common_statistics(world) {
    const ret = wasm.common_statistics(world);
    return takeObject(ret);
}

/**
* @param {number} world
* @returns {boolean}
*/
export function is_dirty(world) {
    const ret = wasm.is_dirty(world);
    return ret !== 0;
}

/**
* @param {number} _world
*/
export function mem_statistics(_world) {
    wasm.mem_statistics(_world);
}

/**
* @param {ResMgr} res_mgr
* @returns {any}
*/
export function res_debug(res_mgr) {
    _assertClass(res_mgr, ResMgr);
    const ret = wasm.res_debug(res_mgr.__wbg_ptr);
    return takeObject(ret);
}

/**
* @param {number} world
*/
export function get_font_sheet_debug(world) {
    wasm.get_font_sheet_debug(world);
}

/**
* @param {number} world
*/
export function get_opcaity(world) {
    wasm.get_opcaity(world);
}

/**
* 打印内存情况
* @param {number} world
*/
export function print_memory(world) {
    wasm.print_memory(world);
}

/**
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function get_world_matrix(world, node) {
    const ret = wasm.get_world_matrix(world, node);
    return takeObject(ret);
}

/**
* @param {number} world
* @param {number} node
* @returns {any}
*/
export function get_transform(world, node) {
    const ret = wasm.get_transform(world, node);
    return takeObject(ret);
}

/**
* 设置字符间距
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_letter_spacing(world, node_id, value) {
    wasm.set_letter_spacing(world, node_id, value);
}

/**
* 设置单词间距
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_word_spacing(world, node_id, value) {
    wasm.set_word_spacing(world, node_id, value);
}

/**
* 设置文字rgba颜色
* @param {number} world
* @param {number} node_id
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_rgba_color(world, node_id, r, g, b, a) {
    wasm.set_text_rgba_color(world, node_id, r, g, b, a);
}

/**
* 设置文字渐变颜色
* __jsObj: color_and_positions: [r, g, b, a, pos,   r, g, b, a, pos], direction: 0-360度
* @param {number} world
* @param {number} node_id
* @param {number} direction
* @param {Float32Array} color_and_positions
*/
export function set_text_linear_gradient_color(world, node_id, direction, color_and_positions) {
    const ptr0 = passArrayF32ToWasm0(color_and_positions, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_linear_gradient_color(world, node_id, direction, ptr0, len0);
}

/**
* 设置行高为normal
* @param {number} world
* @param {number} node_id
*/
export function set_line_height_normal(world, node_id) {
    wasm.set_line_height_normal(world, node_id);
}

/**
* 设置行高的像素值
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_line_height(world, node_id, value) {
    wasm.set_line_height(world, node_id, value);
}

/**
* 设置行高的百分比值
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_line_height_percent(world, node_id, value) {
    wasm.set_line_height_percent(world, node_id, value);
}

/**
* 设置文字首行缩进的像素值
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_text_indent(world, node_id, value) {
    wasm.set_text_indent(world, node_id, value);
}

/**
* 设置文本的水平对齐方式
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_text_align(world, node_id, value) {
    wasm.set_text_align(world, node_id, value);
}

/**
* 设置文字的描边属性
* @param {number} world
* @param {number} node_id
* @param {number} width
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_text_stroke(world, node_id, width, r, g, b, a) {
    wasm.set_text_stroke(world, node_id, width, r, g, b, a);
}

/**
* 设置文字的空白处理方式
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_white_space(world, node_id, value) {
    wasm.set_white_space(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {string} s
*/
export function set_text_shadow(world, node_id, s) {
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_shadow(world, node_id, ptr0, len0);
}

/**
* 设置字体风格
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_font_style(world, node_id, value) {
    wasm.set_font_style(world, node_id, value);
}

/**
* 设置字体粗度
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_font_weight(world, node_id, value) {
    wasm.set_font_weight(world, node_id, value);
}

/**
* 设置字体尺寸为none（使用默认）
* @param {number} world
* @param {number} node_id
*/
export function set_font_size_none(world, node_id) {
    wasm.set_font_size_none(world, node_id);
}

/**
* 设置字体尺寸的像素值
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_font_size(world, node_id, value) {
    wasm.set_font_size(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @returns {any}
*/
export function get_font_size(world, node_id) {
    const ret = wasm.get_font_size(world, node_id);
    return takeObject(ret);
}

/**
* 设置字体尺寸的百分比
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function set_font_size_percent(world, node_id, value) {
    wasm.set_font_size_percent(world, node_id, value);
}

/**
* 设置字体
* __jsObj: family name
* @param {number} world
* @param {number} node_id
* @param {number} name
*/
export function set_font_family(world, node_id, name) {
    wasm.set_font_family(world, node_id, name);
}

/**
* 添加一个msdf字体资源
* 图片            配置
*__jsObj: image , __jsObj1: glyph cfg
* cfg: XHashMap<char, GlyphInfo>
* @param {number} world_id
* @param {number} name
* @param {Uint8Array} cfgs
*/
export function add_sdf_font(world_id, name, cfgs) {
    const ptr0 = passArray8ToWasm0(cfgs, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.add_sdf_font(world_id, name, ptr0, len0);
}

/**
* 添加一个msdf字体资源
* 图片            配置
*__jsObj: image , __jsObj1: glyph cfg
* @param {number} world_id
* @param {HTMLImageElement} image
* @param {Uint8Array} cfg
* @param {number} name
*/
export function add_msdf_font_res(world_id, image, cfg, name) {
    const ptr0 = passArray8ToWasm0(cfg, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.add_msdf_font_res(world_id, addHeapObject(image), ptr0, len0, name);
}

/**
* 设置文本内容
* __jsObj 文字字符串
* @param {number} world_id
* @param {number} node
* @param {string} content
*/
export function set_text_content(world_id, node, content) {
    const ptr0 = passStringToWasm0(content, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_content(world_id, node, ptr0, len0);
}

/**
* 设置文本内容
* 文本内容为utf8编码的Uint8Array，
* @param {number} world_id
* @param {number} node
* @param {Uint8Array} content
*/
export function set_text_content_utf8(world_id, node, content) {
    const ptr0 = passArray8ToWasm0(content, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.set_text_content_utf8(world_id, node, ptr0, len0);
}

/**
* 添加一个canvas字体
* __jsObj1: name(String)
* @param {number} world
* @param {number} factor_t
* @param {number} factor_b
* @param {number} name
*/
export function add_canvas_font(world, factor_t, factor_b, name) {
    wasm.add_canvas_font(world, factor_t, factor_b, name);
}

/**
* 添加font-face
*          字体族名称                        字体名称（逗号分隔）
* __jsObj: family_name(String), __jsObj1: src_name(String, 逗号分隔),
* @param {number} world
* @param {number} oblique
* @param {number} size
* @param {number} weight
* @param {number} family
* @param {Uint32Array} src
*/
export function add_font_face(world, oblique, size, weight, family, src) {
    const ptr0 = passArray32ToWasm0(src, wasm.__wbindgen_malloc);
    const len0 = WASM_VECTOR_LEN;
    wasm.add_font_face(world, oblique, size, weight, family, ptr0, len0);
}

/**
* 更新字体纹理
* __jsObj: canvas
* @param {number} world
* @param {number} u
* @param {number} v
* @param {number} height
* @param {HTMLImageElement} img
*/
export function update_text_texture(world, u, v, height, img) {
    wasm.update_text_texture(world, u, v, height, addHeapObject(img));
}

/**
* 清空所有变换
* @param {number} world
* @param {number} node_id
*/
export function clear_transform(world, node_id) {
    wasm.clear_transform(world, node_id);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} x
* @param {number} y
*/
export function transform_translate(world, node_id, x, y) {
    wasm.transform_translate(world, node_id, x, y);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_translate_x(world, node_id, value) {
    wasm.transform_translate_x(world, node_id, value);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_translate_y(world, node_id, value) {
    wasm.transform_translate_y(world, node_id, value);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} x
* @param {number} y
*/
export function transform_translate_percent(world, node_id, x, y) {
    wasm.transform_translate_percent(world, node_id, x, y);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_translate_x_percent(world, node_id, value) {
    wasm.transform_translate_x_percent(world, node_id, value);
}

/**
* 移动变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_translate_y_percent(world, node_id, value) {
    wasm.transform_translate_y_percent(world, node_id, value);
}

/**
* 缩放变化
* @param {number} world
* @param {number} node_id
* @param {number} x
* @param {number} y
*/
export function transform_scale(world, node_id, x, y) {
    wasm.transform_scale(world, node_id, x, y);
}

/**
* 缩放变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_scale_x(world, node_id, value) {
    wasm.transform_scale_x(world, node_id, value);
}

/**
* 缩放变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_scale_y(world, node_id, value) {
    wasm.transform_scale_y(world, node_id, value);
}

/**
* 旋转变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_rotate_z(world, node_id, value) {
    wasm.transform_rotate_z(world, node_id, value);
}

/**
* 旋转变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_rotate_x(world, node_id, value) {
    wasm.transform_rotate_x(world, node_id, value);
}

/**
* 旋转变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_rotate_y(world, node_id, value) {
    wasm.transform_rotate_y(world, node_id, value);
}

/**
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_skew_x(world, node_id, value) {
    wasm.transform_skew_x(world, node_id, value);
}

/**
* 旋转变化
* @param {number} world
* @param {number} node_id
* @param {number} value
*/
export function transform_skew_y(world, node_id, value) {
    wasm.transform_skew_y(world, node_id, value);
}

/**
* 设置transfrom为none
* @param {number} world
* @param {number} node_id
*/
export function transform_none(world, node_id) {
    wasm.transform_none(world, node_id);
}

/**
* 设置变化原点
* @param {number} world
* @param {number} node_id
* @param {number} x_ty
* @param {number} x
* @param {number} y_ty
* @param {number} y
*/
export function transform_origin(world, node_id, x_ty, x, y_ty, y) {
    wasm.transform_origin(world, node_id, x_ty, x, y_ty, y);
}

/**
* @param {number} world_id
*/
export function resume(world_id) {
    wasm.resume(world_id);
}

/**
* 调试使用， 设置渲染脏， 使渲染系统在下一帧进行渲染
* @param {number} world
*/
export function set_render_dirty(world) {
    wasm.set_render_dirty(world);
}

/**
* total_capacity: 资源管理器总容量, 如果为0， 将使用默认的容量设置
* @param {any} gl
* @param {ResMgr} res_mgr
* @returns {number}
*/
export function create_engine(gl, res_mgr) {
    _assertClass(res_mgr, ResMgr);
    const ret = wasm.create_engine(addHeapObject(gl), res_mgr.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {number} world
* @returns {number}
*/
export function get_font_sheet(world) {
    const ret = wasm.get_font_sheet(world);
    return ret >>> 0;
}

/**
* @param {number} world
* @returns {number}
*/
export function get_class_sheet(world) {
    const ret = wasm.get_class_sheet(world);
    return ret >>> 0;
}

/**
* 创建渲染目标， 返回渲染目标的指针， 必须要高层调用destroy_render_target接口， 该渲染目标才能得到释放
* @param {number} world
* @param {WebGLFramebuffer} fbo
* @returns {number}
*/
export function create_render_target(world, fbo) {
    const ret = wasm.create_render_target(world, addHeapObject(fbo));
    return ret >>> 0;
}

/**
* 销毁渲染目标
* @param {number} render_target
*/
export function destroy_render_target(render_target) {
    wasm.destroy_render_target(render_target);
}

/**
* 绑定rendertarget
* render_target为0时， 表示绑定gl默认的渲染目标， 当大于0时， render_target必须是一个RenderTarget的指针
* @param {number} world_id
* @param {number} render_target
*/
export function bind_render_target(world_id, render_target) {
    wasm.bind_render_target(world_id, render_target);
}

/**
* 克隆渲染引擎（某些情况下， 需要多个gui实例共享同一个渲染引擎）
* @param {number} engine
* @returns {number}
*/
export function clone_engine(engine) {
    const ret = wasm.clone_engine(engine);
    return ret >>> 0;
}

/**
* 创建gui实例
* @param {number} engine
* @param {number} width
* @param {number} height
* @param {Function | undefined} load_image_fun
* @param {number} class_sheet
* @param {number} font_sheet
* @param {boolean} is_sdf_font
* @returns {number}
*/
export function create_gui(engine, width, height, load_image_fun, class_sheet, font_sheet, is_sdf_font) {
    const ret = wasm.create_gui(engine, width, height, isLikeNone(load_image_fun) ? 0 : addHeapObject(load_image_fun), class_sheet, font_sheet, is_sdf_font);
    return ret >>> 0;
}

/**
* @param {number} world
* @returns {number}
*/
export function get_text_texture_width(world) {
    const ret = wasm.get_text_texture_width(world);
    return ret >>> 0;
}

/**
* @param {number} world
* @returns {number}
*/
export function get_text_texture_height(world) {
    const ret = wasm.get_text_texture_height(world);
    return ret >>> 0;
}

/**
* 创建gui实例
* @param {number} world
* @param {number} pixel_ratio
*/
export function set_pixel_ratio(world, pixel_ratio) {
    wasm.set_pixel_ratio(world, pixel_ratio);
}

/**
* 设置gui渲染的清屏颜色
* @param {number} world
* @param {number} r
* @param {number} g
* @param {number} b
* @param {number} a
*/
export function set_clear_color(world, r, g, b, a) {
    wasm.set_clear_color(world, r, g, b, a);
}

/**
* 使gui渲染不清屏
* @param {number} world
*/
export function nullify_clear_color(world) {
    wasm.nullify_clear_color(world);
}

/**
* 设置视口
* @param {number} world_id
* @param {number} x
* @param {number} y
* @param {number} width
* @param {number} height
*/
export function set_view_port(world_id, x, y, width, height) {
    wasm.set_view_port(world_id, x, y, width, height);
}

/**
* 设置视口
* @param {number} world_id
* @param {number} x
* @param {number} y
* @param {number} width
* @param {number} height
*/
export function set_scissor(world_id, x, y, width, height) {
    wasm.set_scissor(world_id, x, y, width, height);
}

/**
* 设置投影变换
* @param {number} world_id
* @param {number} scale_x
* @param {number} scale_y
* @param {number} translate_x
* @param {number} translate_y
* @param {number} rotate
* @param {number} width
* @param {number} height
*/
export function set_project_transfrom(world_id, scale_x, scale_y, translate_x, translate_y, rotate, width, height) {
    wasm.set_project_transfrom(world_id, scale_x, scale_y, translate_x, translate_y, rotate, width, height);
}

/**
*
* * 文字纹理绘制时， 总是按照第一次取到的节点缩放值以及文字本身的样式来绘制， 以后更改缩放值， 无法重绘纹理
* * 调用此犯法，可强制更新一次缩放值
*
* @param {number} world_id
* @param {number} node_id
*/
export function force_update_text(world_id, node_id) {
    wasm.force_update_text(world_id, node_id);
}

/**
* 渲染gui， 通常每帧调用
* @param {number} world_id
* @returns {Promise<any>}
*/
export function render(world_id) {
    const ret = wasm.render(world_id);
    return takeObject(ret);
}

/**
* 强制计算一次
* @param {number} world_id
*/
export function calc(world_id) {
    wasm.calc(world_id);
}

/**
* @param {number} world_id
*/
export function calc_geo(world_id) {
    wasm.calc_geo(world_id);
}

/**
* 强制计算一次布局
* @param {number} world_id
*/
export function cal_layout(world_id) {
    wasm.cal_layout(world_id);
}

/**
* @param {number} engine
* @param {string} shader_name
* @param {string} shader_code
*/
export function set_shader(engine, shader_name, shader_code) {
    const ptr0 = passStringToWasm0(shader_name, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ptr1 = passStringToWasm0(shader_code, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len1 = WASM_VECTOR_LEN;
    wasm.set_shader(engine, ptr0, len0, ptr1, len1);
}

/**
* 加载图片成功后调用
* image_name可以使用hash值与高层交互 TODO
* __jsObj: image, __jsObj1: image_name(String)
* @param {number} world_id
* @param {PixelFormat} pformate
* @param {number} compress
* @param {number} r_type
* @param {number} name
* @param {number} width
* @param {number} height
* @param {object} data
* @param {number} cost
*/
export function load_image_success(world_id, pformate, compress, r_type, name, width, height, data, cost) {
    wasm.load_image_success(world_id, pformate, compress, r_type, name, width, height, addHeapObject(data), cost);
}

/**
* @param {number} world
* @param {number} x
* @param {number} y
* @param {number} w
* @param {number} h
* @param {Uint8Array} data
*/
export function load_sdf_success(world, x, y, w, h, data) {
    wasm.load_sdf_success(world, x, y, w, h, addHeapObject(data));
}

/**
* 创建纹理资源
* image_name可以使用hash值与高层交互 TODO
* @param {number} world_id
* @param {PixelFormat} pformate
* @param {number} compress
* @param {number} r_type
* @param {number} name
* @param {number} width
* @param {number} height
* @param {object} data
* @param {number} cost
* @returns {number}
*/
export function create_texture_res(world_id, pformate, compress, r_type, name, width, height, data, cost) {
    const ret = wasm.create_texture_res(world_id, pformate, compress, r_type, name, width, height, addHeapObject(data), cost);
    return ret >>> 0;
}

/**
* @param {number} texture
*/
export function destroy_texture_res(texture) {
    wasm.destroy_texture_res(texture);
}

/**
* 纹理是否存在, 返回0表示不存在
* @param {number} world
* @param {number} group_i
* @param {number} name
* @returns {boolean}
*/
export function texture_is_exist(world, group_i, name) {
    const ret = wasm.texture_is_exist(world, group_i, name);
    return ret !== 0;
}

/**
* @param {string} s
* @returns {Atom}
*/
export function get_atom(s) {
    const ptr0 = passStringToWasm0(s, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
    const len0 = WASM_VECTOR_LEN;
    const ret = wasm.get_atom(ptr0, len0);
    return Atom.__wrap(ret);
}

/**
* @param {Atom} s
* @returns {number}
*/
export function get_atom_hash(s) {
    _assertClass(s, Atom);
    const ret = wasm.get_atom_hash(s.__wbg_ptr);
    return ret >>> 0;
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_text_content(world, node_id) {
    wasm.reset_text_content(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_font_style(world, node_id) {
    wasm.reset_font_style(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_font_weight(world, node_id) {
    wasm.reset_font_weight(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_font_size(world, node_id) {
    wasm.reset_font_size(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_font_family(world, node_id) {
    wasm.reset_font_family(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_letter_spacing(world, node_id) {
    wasm.reset_letter_spacing(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_word_spacing(world, node_id) {
    wasm.reset_word_spacing(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_line_height(world, node_id) {
    wasm.reset_line_height(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_indent(world, node_id) {
    wasm.reset_indent(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_white_space(world, node_id) {
    wasm.reset_white_space(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_text_align(world, node_id) {
    wasm.reset_text_align(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_vertical_align(world, node_id) {
    wasm.reset_vertical_align(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_color(world, node_id) {
    wasm.reset_color(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_stroke(world, node_id) {
    wasm.reset_stroke(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_text_shadow(world, node_id) {
    wasm.reset_text_shadow(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_image(world, node_id) {
    wasm.reset_image(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_image_clip(world, node_id) {
    wasm.reset_image_clip(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_object_fit(world, node_id) {
    wasm.reset_object_fit(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_image(world, node_id) {
    wasm.reset_border_image(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_image_clip(world, node_id) {
    wasm.reset_border_image_clip(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_image_slice(world, node_id) {
    wasm.reset_border_image_slice(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_image_repeat(world, node_id) {
    wasm.reset_border_image_repeat(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_color(world, node_id) {
    wasm.reset_border_color(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_radius(world, node_id) {
    wasm.reset_border_radius(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_background_color(world, node_id) {
    wasm.reset_background_color(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_box_shadow(world, node_id) {
    wasm.reset_box_shadow(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_filter(world, node_id) {
    wasm.reset_filter(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_opacity(world, node_id) {
    wasm.reset_opacity(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_direction(world, node_id) {
    wasm.reset_direction(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_order(world, node_id) {
    wasm.reset_order(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_flex_basis(world, node_id) {
    wasm.reset_flex_basis(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_z_index(world, node_id) {
    wasm.reset_z_index(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_transform(world, node_id) {
    wasm.reset_transform(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_transform_will_change(world, node_id) {
    wasm.reset_transform_will_change(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_overflow(world, node_id) {
    wasm.reset_overflow(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_mask_image(world, node_id) {
    wasm.reset_mask_image(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_mask_image_clip(world, node_id) {
    wasm.reset_mask_image_clip(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_width(world, node_id) {
    wasm.reset_width(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_height(world, node_id) {
    wasm.reset_height(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_margin_top(world, node_id) {
    wasm.reset_margin_top(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_margin_right(world, node_id) {
    wasm.reset_margin_right(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_margin_bottom(world, node_id) {
    wasm.reset_margin_bottom(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_margin_left(world, node_id) {
    wasm.reset_margin_left(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_top(world, node_id) {
    wasm.reset_top(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_right(world, node_id) {
    wasm.reset_right(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_bottom(world, node_id) {
    wasm.reset_bottom(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_left(world, node_id) {
    wasm.reset_left(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_padding_top(world, node_id) {
    wasm.reset_padding_top(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_padding_right(world, node_id) {
    wasm.reset_padding_right(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_padding_bottom(world, node_id) {
    wasm.reset_padding_bottom(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_padding_left(world, node_id) {
    wasm.reset_padding_left(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_top(world, node_id) {
    wasm.reset_border_top(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_right(world, node_id) {
    wasm.reset_border_right(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_bottom(world, node_id) {
    wasm.reset_border_bottom(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_border_left(world, node_id) {
    wasm.reset_border_left(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_min_width(world, node_id) {
    wasm.reset_min_width(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_min_height(world, node_id) {
    wasm.reset_min_height(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_max_width(world, node_id) {
    wasm.reset_max_width(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_max_height(world, node_id) {
    wasm.reset_max_height(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_justify_content(world, node_id) {
    wasm.reset_justify_content(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_flex_shrink(world, node_id) {
    wasm.reset_flex_shrink(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_flex_grow(world, node_id) {
    wasm.reset_flex_grow(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_position_type(world, node_id) {
    wasm.reset_position_type(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_flex_wrap(world, node_id) {
    wasm.reset_flex_wrap(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_flex_direction(world, node_id) {
    wasm.reset_flex_direction(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_align_content(world, node_id) {
    wasm.reset_align_content(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_align_items(world, node_id) {
    wasm.reset_align_items(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_align_self(world, node_id) {
    wasm.reset_align_self(world, node_id);
}

/**
* @param {number} world
* @param {number} node_id
*/
export function reset_blend_mode(world, node_id) {
    wasm.reset_blend_mode(world, node_id);
}

/**
* 设置display
* @param {number} world
* @param {number} node
*/
export function reset_display(world, node) {
    wasm.reset_display(world, node);
}

/**
* 设置visibility, true: visible, false: hidden,	默认true
* @param {number} world
* @param {number} node
*/
export function reset_visibility(world, node) {
    wasm.reset_visibility(world, node);
}

/**
* 设置enable
* @param {number} world
* @param {number} node
*/
export function reset_enable(world, node) {
    wasm.reset_enable(world, node);
}

function handleError(f, args) {
    try {
        return f.apply(this, args);
    } catch (e) {
        wasm.__wbindgen_exn_store(addHeapObject(e));
    }
}

function getArrayF32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getFloat32ArrayMemory0().subarray(ptr / 4, ptr / 4 + len);
}
/**
*/
export function bon_debug() {
    wasm.bon_debug();
}

/**
* @param {Uint8Array} data
* @returns {Uint8Array}
*/
export function decompress_br(data) {
    try {
        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
        const ptr0 = passArray8ToWasm0(data, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.decompress_br(retptr, ptr0, len0);
        var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
        var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
        var v2 = getArrayU8FromWasm0(r0, r1).slice();
        wasm.__wbindgen_free(r0, r1 * 1, 1);
        return v2;
    } finally {
        wasm.__wbindgen_add_to_stack_pointer(16);
    }
}

/**
* @returns {Uint8Array}
*/
export function test_uint8array() {
    const ret = wasm.test_uint8array();
    return takeObject(ret);
}

/**
* @returns {Map<any, any>}
*/
export function test_map() {
    const ret = wasm.test_map();
    return takeObject(ret);
}

/**
* @returns {Array<any>}
*/
export function test_arr() {
    const ret = wasm.test_arr();
    return takeObject(ret);
}

/**
* @returns {object}
*/
export function test_obj() {
    const ret = wasm.test_obj();
    return takeObject(ret);
}

/**
* @returns {ConfigMgr}
*/
export function test_mgr() {
    const ret = wasm.test_mgr();
    return ConfigMgr.__wrap(ret);
}

let cachedInt32ArrayMemory0 = null;

function getInt32ArrayMemory0() {
    if (cachedInt32ArrayMemory0 === null || cachedInt32ArrayMemory0.byteLength === 0) {
        cachedInt32ArrayMemory0 = new Int32Array(wasm.memory.buffer);
    }
    return cachedInt32ArrayMemory0;
}

function getArrayI32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getInt32ArrayMemory0().subarray(ptr / 4, ptr / 4 + len);
}

let cachedFloat64ArrayMemory0 = null;

function getFloat64ArrayMemory0() {
    if (cachedFloat64ArrayMemory0 === null || cachedFloat64ArrayMemory0.byteLength === 0) {
        cachedFloat64ArrayMemory0 = new Float64Array(wasm.memory.buffer);
    }
    return cachedFloat64ArrayMemory0;
}

function getArrayF64FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getFloat64ArrayMemory0().subarray(ptr / 8, ptr / 8 + len);
}

function passArrayF64ToWasm0(arg, malloc) {
    const ptr = malloc(arg.length * 8, 8) >>> 0;
    getFloat64ArrayMemory0().set(arg, ptr / 8);
    WASM_VECTOR_LEN = arg.length;
    return ptr;
}

function getArrayU32FromWasm0(ptr, len) {
    ptr = ptr >>> 0;
    return getUint32ArrayMemory0().subarray(ptr / 4, ptr / 4 + len);
}
/**
*/
export const PixelFormat = Object.freeze({ RGB:0,"0":"RGB",RGBA:1,"1":"RGBA",ALPHA:2,"2":"ALPHA",DEPTH16:3,"3":"DEPTH16",LUMINANCE:4,"4":"LUMINANCE", });
/**
*/
export const BlendMode = Object.freeze({ Normal:0,"0":"Normal",AlphaAdd:1,"1":"AlphaAdd",Subtract:2,"2":"Subtract",Multiply:3,"3":"Multiply",OneOne:4,"4":"OneOne", });
/**
* Initializes the global logger setting `max_log_level` to the given value.
*/
export const Level = Object.freeze({
/**
* The "error" level.
*
* Designates very serious errors.
*/
Error:1,"1":"Error",
/**
* The "warn" level.
*
* Designates hazardous situations.
*/
Warn:2,"2":"Warn",
/**
* The "info" level.
*
* Designates useful information.
*/
Info:3,"3":"Info",
/**
* The "debug" level.
*
* Designates lower priority information.
*/
Debug:4,"4":"Debug",
/**
* The "trace" level.
*
* Designates very low priority, often extremely verbose, information.
*/
Trace:5,"5":"Trace", });
/**
*/
export const TileFlagType = Object.freeze({ All:0,"0":"All",Center:1,"1":"Center",Right:2,"2":"Right",Down:4,"4":"Down", });
/**
*/
export const Direction = Object.freeze({ Left:0,"0":"Left",Right:1,"1":"Right",Up:2,"2":"Up",Down:3,"3":"Down", });

const AStarFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_astar_free(ptr >>> 0, 1));
/**
*/
export class AStar {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(AStar.prototype);
        obj.__wbg_ptr = ptr;
        AStarFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        AStarFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_astar_free(ptr, 0);
    }
    /**
    * @param {number} width
    * @param {number} height
    * @param {number} node_number
    * @returns {AStar}
    */
    static new(width, height, node_number) {
        const ret = wasm.astar_new(width, height, node_number);
        return AStar.__wrap(ret);
    }
    /**
    * @param {TileMap} tile_map
    * @param {number} max_number
    * @param {number} start
    * @param {number} end
    * @param {number} center_flag
    * @param {number} side_flag
    * @returns {number | undefined}
    */
    find_path(tile_map, max_number, start, end, center_flag, side_flag) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            _assertClass(tile_map, TileMap);
            wasm.astar_find_path(retptr, this.__wbg_ptr, tile_map.__wbg_ptr, max_number, start, end, center_flag, side_flag);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} node
    * @param {TileMap} tile_map
    * @param {number} center_flag
    * @param {number} side_flag
    */
    result(node, tile_map, center_flag, side_flag) {
        _assertClass(tile_map, TileMap);
        wasm.astar_result(this.__wbg_ptr, node, tile_map.__wbg_ptr, center_flag, side_flag);
    }
}

const AtomFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_atom_free(ptr >>> 0, 1));
/**
*/
export class Atom {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(Atom.prototype);
        obj.__wbg_ptr = ptr;
        AtomFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        AtomFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_atom_free(ptr, 0);
    }
}

const BaseShape1Finalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_baseshape1_free(ptr >>> 0, 1));
/**
*/
export class BaseShape1 {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(BaseShape1.prototype);
        obj.__wbg_ptr = ptr;
        BaseShape1Finalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        BaseShape1Finalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_baseshape1_free(ptr, 0);
    }
}

const ConfigMgrFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_configmgr_free(ptr >>> 0, 1));
/**
*/
export class ConfigMgr {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ConfigMgr.prototype);
        obj.__wbg_ptr = ptr;
        ConfigMgrFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ConfigMgrFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_configmgr_free(ptr, 0);
    }
    /**
    * @param {number} cache_size
    * @param {number} timeout
    * @returns {ConfigMgr}
    */
    static init(cache_size, timeout) {
        const ret = wasm.configmgr_init(cache_size, timeout);
        return ConfigMgr.__wrap(ret);
    }
    /**
    * @param {Uint8Array} buffer
    */
    add_buffer(buffer) {
        const ptr0 = passArray8ToWasm0(buffer, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        wasm.configmgr_add_buffer(this.__wbg_ptr, ptr0, len0);
    }
    /**
    * @param {number} tab
    * @param {any} key
    * @returns {any}
    */
    get_config(tab, key) {
        const ret = wasm.configmgr_get_config(this.__wbg_ptr, tab, addHeapObject(key));
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @returns {string | undefined}
    */
    get_struct_info(tab) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.configmgr_get_struct_info(retptr, this.__wbg_ptr, tab);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            let v1;
            if (r0 !== 0) {
                v1 = getStringFromWasm0(r0, r1).slice();
                wasm.__wbindgen_free(r0, r1 * 1, 1);
            }
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_tab(tab) {
        const ret = wasm.configmgr_get_tab(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @param {any} key
    * @returns {boolean}
    */
    get_config_buffer(tab, key) {
        const ret = wasm.configmgr_get_config_buffer(this.__wbg_ptr, tab, addHeapObject(key));
        return ret !== 0;
    }
    /**
    * @param {number} tab
    * @returns {TabBuffer | undefined}
    */
    get_tab_buffer(tab) {
        const ret = wasm.configmgr_get_tab_buffer(this.__wbg_ptr, tab);
        return ret === 0 ? null : TabBuffer.__wrap(ret);
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_keys(tab) {
        const ret = wasm.configmgr_get_keys(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
    /**
    * @param {number} tab
    * @returns {any}
    */
    get_infos(tab) {
        const ret = wasm.configmgr_get_infos(this.__wbg_ptr, tab);
        return takeObject(ret);
    }
}

const JsResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_jsres_free(ptr >>> 0, 1));
/**
* 资源包装
*/
export class JsRes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(JsRes.prototype);
        obj.__wbg_ptr = ptr;
        JsResFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        JsResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_jsres_free(ptr, 0);
    }
    /**
    * @param {Res} res
    * @returns {JsRes}
    */
    static new(res) {
        const ret = wasm.jsres_new(addHeapObject(res));
        return JsRes.__wrap(ret);
    }
    /**
    * 创建一个资源， 如果资源已经存在，则会修改资源的配置
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} min_capacity
    * @param {number} max_capacity
    * @param {number} time_out
    */
    static register_to_resmgr(mgr, ty, min_capacity, max_capacity, time_out) {
        _assertClass(mgr, ResMgr);
        wasm.jsres_register_to_resmgr(mgr.__wbg_ptr, ty, min_capacity, max_capacity, time_out);
    }
    /**
    * 创建一个资源， 如果资源已经存在，旧的资源将被覆盖
    * 如果创建的资源类型未注册，将崩溃
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} key
    * @param {number} cost
    * @returns {ResRef}
    */
    create_res(mgr, ty, key, cost) {
        const ptr = this.__destroy_into_raw();
        _assertClass(mgr, ResMgr);
        const ret = wasm.jsres_create_res(ptr, mgr.__wbg_ptr, ty, key, cost);
        return ResRef.__wrap(ret);
    }
    /**
    * 获取资源
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} key
    * @returns {ResRef | undefined}
    */
    static get_res(mgr, ty, key) {
        _assertClass(mgr, ResMgr);
        const ret = wasm.jsres_get_res(mgr.__wbg_ptr, ty, key);
        return ret === 0 ? null : ResRef.__wrap(ret);
    }
}

const NativeResRefFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_nativeresref_free(ptr >>> 0, 1));
/**
*/
export class NativeResRef {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(NativeResRef.prototype);
        obj.__wbg_ptr = ptr;
        NativeResRefFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        NativeResRefFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_nativeresref_free(ptr, 0);
    }
}

const QuadTreeFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_quadtree_free(ptr >>> 0, 1));
/**
*/
export class QuadTree {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(QuadTree.prototype);
        obj.__wbg_ptr = ptr;
        QuadTreeFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        QuadTreeFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_quadtree_free(ptr, 0);
    }
    /**
    * @returns {QuadTree}
    */
    static default() {
        const ret = wasm.quadtree_default();
        return QuadTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {number} min_loose_x
    * @param {number} min_loose_y
    * @param {number} max_loose_x
    * @param {number} max_loose_y
    * @returns {QuadTree}
    */
    static new(min_x, min_y, max_x, max_y, min_loose_x, min_loose_y, max_loose_x, max_loose_y) {
        const ret = wasm.quadtree_new(min_x, min_y, max_x, max_y, min_loose_x, min_loose_y, max_loose_x, max_loose_y);
        return QuadTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {number}
    */
    add(min_x, min_y, max_x, max_y) {
        const ret = wasm.quadtree_add(this.__wbg_ptr, min_x, min_y, max_x, max_y);
        return ret;
    }
    /**
    * @param {number} id
    */
    remove(id) {
        wasm.quadtree_remove(this.__wbg_ptr, id);
    }
    /**
    * @param {number} id
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    */
    update(id, min_x, min_y, max_x, max_y) {
        wasm.quadtree_update(this.__wbg_ptr, id, min_x, min_y, max_x, max_y);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {Float64Array}
    */
    query(min_x, min_y, max_x, max_y) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.quadtree_query(retptr, this.__wbg_ptr, min_x, min_y, max_x, max_y);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            var v1 = getArrayF64FromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 8, 8);
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {Float64Array} result
    * @param {number} max_len
    * @returns {number}
    */
    query_max(min_x, min_y, max_x, max_y, result, max_len) {
        var ptr0 = passArrayF64ToWasm0(result, wasm.__wbindgen_malloc);
        var len0 = WASM_VECTOR_LEN;
        const ret = wasm.quadtree_query_max(this.__wbg_ptr, min_x, min_y, max_x, max_y, ptr0, len0, addHeapObject(result), max_len);
        return ret;
    }
}

const RVOSimulatorFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_rvosimulator_free(ptr >>> 0, 1));
/**
*/
export class RVOSimulator {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(RVOSimulator.prototype);
        obj.__wbg_ptr = ptr;
        RVOSimulatorFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        RVOSimulatorFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_rvosimulator_free(ptr, 0);
    }
    /**
    * @param {number} time_step
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @param {number} rng_seed
    * @returns {RVOSimulator}
    */
    static new(time_step, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y, rng_seed) {
        const ret = wasm.rvosimulator_new(time_step, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y, rng_seed);
        return RVOSimulator.__wrap(ret);
    }
    /**
    * @returns {RVOSimulator}
    */
    static default() {
        const ret = wasm.rvosimulator_default();
        return RVOSimulator.__wrap(ret);
    }
    /**
    * @param {number} position_x
    * @param {number} position_y
    * @param {number} speed
    * @returns {number}
    */
    add_agent(position_x, position_y, speed) {
        const ret = wasm.rvosimulator_add_agent(this.__wbg_ptr, position_x, position_y, speed);
        return ret;
    }
    /**
    * @param {number} position_x
    * @param {number} position_y
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @returns {number}
    */
    add_agent2(position_x, position_y, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y) {
        const ret = wasm.rvosimulator_add_agent2(this.__wbg_ptr, position_x, position_y, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y);
        return ret;
    }
    /**
    * @param {number} id
    * @returns {boolean}
    */
    remove_agent(id) {
        const ret = wasm.rvosimulator_remove_agent(this.__wbg_ptr, id);
        return ret !== 0;
    }
    /**
    *
    *     * @brief 为模拟添加新障碍。
    *     * @param[in] vertices 逆时针顺序排列的多边形障碍物的顶点列表。
    *     * @return 障碍物第一个顶点的编号，当顶点数小于2时为返回usize::MAX。
    *     * @note 要添加“负面”障碍，例如环境周围的边界多边形，顶点应按顺时针顺序列出。
    *
    * @param {Float32Array} vertices
    * @returns {number}
    */
    add_obstacle(vertices) {
        const ptr0 = passArrayF32ToWasm0(vertices, wasm.__wbindgen_malloc);
        const len0 = WASM_VECTOR_LEN;
        const ret = wasm.rvosimulator_add_obstacle(this.__wbg_ptr, ptr0, len0);
        return ret;
    }
    /**
    * @param {number} id
    * @returns {boolean}
    */
    remove_obstacle(id) {
        const ret = wasm.rvosimulator_remove_obstacle(this.__wbg_ptr, id);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    do_step() {
        const ret = wasm.rvosimulator_do_step(this.__wbg_ptr);
        return ret !== 0;
    }
    /**
    *
    *    * @brief     为添加的任何新代理设置默认属性。
    *    * @param[in] neighborDist    新代理在导航中考虑的默认最大中心点到中心点到其他代理的最大距离。
    *                                 这个数字越大，模拟的运行时间就越长。
    *                                 如果数字太低，模拟将不安全。
    *                                 必须是非负数。
    *    * @param[in] maxNeighbors    新代理在导航中考虑的默认最大其他代理数。
    *                                 这个数字越大，模拟的运行时间越长。
    *                                 如果数字太低，模拟将不安全。
    *    * @param[in] timeHorizon     模拟计算的新代理速度相对于其他代理安全的默认最小时间量。
    *                                 这个数字越大，代理就会越快响应其他代理的存在，但代理在选择速度方面的自由度就越小。
    *                                 必须是正数。
    *    * @param[in] timeHorizonObst 通过模拟计算的新代理的速度相对于障碍物是安全的默认最小时间量。
    *                                 这个数字越大，代理越快响应障碍的存在，但代理的自由度越低 选择它的速度。
    *                                 必须是正数。
    *    * @param[in] radius          新代理的默认半径。 必须是非负数。
    *    * @param[in] maxSpeed        新代理的默认最大速度。 必须是非负数。
    *
    * @param {number} neighbor_dist
    * @param {number} max_neighbors
    * @param {number} time_horizon
    * @param {number} time_horizon_obst
    * @param {number} radius
    * @param {number} max_speed
    * @param {number} velocity_x
    * @param {number} velocity_y
    */
    set_agent_defaults(neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y) {
        wasm.rvosimulator_set_agent_defaults(this.__wbg_ptr, neighbor_dist, max_neighbors, time_horizon, time_horizon_obst, radius, max_speed, velocity_x, velocity_y);
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_no
    * @returns {number | undefined}
    */
    get_agent_agent_neighbor(agent_no, neighbor_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_agent_neighbor(retptr, this.__wbg_ptr, agent_no, neighbor_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r2 = getDataViewMemory0().getFloat64(retptr + 8 * 1, true);
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_max_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_max_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_max_speed(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_max_speed(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_neighbor_dist(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_neighbor_dist(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_agent_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_agent_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_obstacle_neighbors(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_obstacle_neighbors(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_num_orcalines(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_num_orcalines(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1 >>> 0;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_no
    * @returns {number | undefined}
    */
    get_agent_obstacle_neighbor(agent_no, neighbor_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_obstacle_neighbor(retptr, this.__wbg_ptr, agent_no, neighbor_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r2 = getDataViewMemory0().getFloat64(retptr + 8 * 1, true);
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_position(agent_no) {
        const ret = wasm.rvosimulator_get_agent_position(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_pref_velocity(agent_no) {
        const ret = wasm.rvosimulator_get_agent_pref_velocity(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_radius(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_radius(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_time_horizon(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_time_horizon(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_time_horizon_obst(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_time_horizon(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_velocity(agent_no) {
        const ret = wasm.rvosimulator_get_agent_velocity(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @returns {number}
    */
    get_global_time() {
        const ret = wasm.rvosimulator_get_global_time(this.__wbg_ptr);
        return ret;
    }
    /**
    * @returns {number}
    */
    get_num_agents() {
        const ret = wasm.rvosimulator_get_num_agents(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
    * @returns {number}
    */
    get_num_obstacle_vertices() {
        const ret = wasm.rvosimulator_get_num_obstacle_vertices(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
    * @param {number} vertex_no
    * @returns {any}
    */
    get_obstacle_vertex(vertex_no) {
        const ret = wasm.rvosimulator_get_obstacle_vertex(this.__wbg_ptr, vertex_no);
        return takeObject(ret);
    }
    /**
    * @param {number} vertex_no
    * @returns {number | undefined}
    */
    get_next_obstacle_vertex_no(vertex_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_next_obstacle_vertex_no(retptr, this.__wbg_ptr, vertex_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r2 = getDataViewMemory0().getFloat64(retptr + 8 * 1, true);
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} vertex_no
    * @returns {number | undefined}
    */
    get_prev_obstacle_vertex_no(vertex_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_prev_obstacle_vertex_no(retptr, this.__wbg_ptr, vertex_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r2 = getDataViewMemory0().getFloat64(retptr + 8 * 1, true);
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @returns {number}
    */
    get_time_step() {
        const ret = wasm.rvosimulator_get_time_step(this.__wbg_ptr);
        return ret;
    }
    /**
    * @param {number} agent_no
    * @param {number} max_neighbors
    * @returns {boolean}
    */
    set_agent_max_neighbors(agent_no, max_neighbors) {
        const ret = wasm.rvosimulator_set_agent_max_neighbors(this.__wbg_ptr, agent_no, max_neighbors);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} max_speed
    * @returns {boolean}
    */
    set_agent_max_speed(agent_no, max_speed) {
        const ret = wasm.rvosimulator_set_agent_max_speed(this.__wbg_ptr, agent_no, max_speed);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} neighbor_dist
    * @returns {boolean}
    */
    set_agent_neighbor_dist(agent_no, neighbor_dist) {
        const ret = wasm.rvosimulator_set_agent_neighbor_dist(this.__wbg_ptr, agent_no, neighbor_dist);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} position_x
    * @param {number} position_y
    * @returns {boolean}
    */
    set_agent_position(agent_no, position_x, position_y) {
        const ret = wasm.rvosimulator_set_agent_position(this.__wbg_ptr, agent_no, position_x, position_y);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} pref_velocity_x
    * @param {number} pref_velocity_y
    * @returns {boolean}
    */
    set_agent_pref_velocity(agent_no, pref_velocity_x, pref_velocity_y) {
        const ret = wasm.rvosimulator_set_agent_pref_velocity(this.__wbg_ptr, agent_no, pref_velocity_x, pref_velocity_y);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} radius
    * @returns {boolean}
    */
    set_agent_radius(agent_no, radius) {
        const ret = wasm.rvosimulator_set_agent_radius(this.__wbg_ptr, agent_no, radius);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} time_horizon
    * @returns {boolean}
    */
    set_agent_time_horizon(agent_no, time_horizon) {
        const ret = wasm.rvosimulator_set_agent_time_horizon(this.__wbg_ptr, agent_no, time_horizon);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} time_horizon_obst
    * @returns {boolean}
    */
    set_agent_time_horizon_obst(agent_no, time_horizon_obst) {
        const ret = wasm.rvosimulator_set_agent_time_horizon_obst(this.__wbg_ptr, agent_no, time_horizon_obst);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @param {number} velocity_x
    * @param {number} velocity_y
    * @returns {boolean}
    */
    set_agent_velocity(agent_no, velocity_x, velocity_y) {
        const ret = wasm.rvosimulator_set_agent_velocity(this.__wbg_ptr, agent_no, velocity_x, velocity_y);
        return ret !== 0;
    }
    /**
    * @param {number} time_step
    */
    set_time_step(time_step) {
        wasm.rvosimulator_set_time_step(this.__wbg_ptr, time_step);
    }
    /**
    *
    *     * @brief     为代理设置目标点。
    *     * @param[in] agent_no   代理id
    *     * @param[in] goal       目标点
    *     * @return 设置成功返回true，失败返回false。
    *
    * @param {number} agent_no
    * @param {number | undefined} [goal_x]
    * @param {number | undefined} [goal_y]
    * @returns {boolean}
    */
    set_agent_goal(agent_no, goal_x, goal_y) {
        const ret = wasm.rvosimulator_set_agent_goal(this.__wbg_ptr, agent_no, !isLikeNone(goal_x), isLikeNone(goal_x) ? 0 : goal_x, !isLikeNone(goal_y), isLikeNone(goal_y) ? 0 : goal_y);
        return ret !== 0;
    }
    /**
    *
    *     * @brief     为代理设置自定义速度。
    *     * @param[in] agent_no   代理id
    *     * @param[in] speed      速度，应该小于代理的最大速度，否则使用最大速度。
    *     * @return 设置成功返回true，失败返回false。
    *
    * @param {number} agent_no
    * @param {number} speed
    * @returns {boolean}
    */
    set_agent_custom_speed(agent_no, speed) {
        const ret = wasm.rvosimulator_set_agent_custom_speed(this.__wbg_ptr, agent_no, speed);
        return ret !== 0;
    }
    /**
    * @param {number} agent_no
    * @returns {any}
    */
    get_agent_goal(agent_no) {
        const ret = wasm.rvosimulator_get_agent_goal(this.__wbg_ptr, agent_no);
        return takeObject(ret);
    }
    /**
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_custom_speed(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_custom_speed(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getFloat32(retptr + 4 * 1, true);
            return r0 === 0 ? null : r1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
    /**
    * @param {number} seed
    */
    set_rng_seed(seed) {
        wasm.rvosimulator_set_rng_seed(this.__wbg_ptr, seed);
    }
    /**
    * @param {number} agent_no
    * @param {number} line_no
    * @returns {any}
    */
    get_agent_orcaline(agent_no, line_no) {
        const ret = wasm.rvosimulator_get_agent_orcaline(this.__wbg_ptr, agent_no, line_no);
        return takeObject(ret);
    }
    /**
    * 设置代理的质量; 1.0为默认值, 必须大于0
    * @param {number} agent_no
    * @param {number} quality
    * @returns {boolean}
    */
    set_agent_quality(agent_no, quality) {
        const ret = wasm.rvosimulator_set_agent_quality(this.__wbg_ptr, agent_no, quality);
        return ret !== 0;
    }
    /**
    * 获取代理的质量
    * @param {number} agent_no
    * @returns {number | undefined}
    */
    get_agent_quality(agent_no) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.rvosimulator_get_agent_quality(retptr, this.__wbg_ptr, agent_no);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r2 = getDataViewMemory0().getFloat64(retptr + 8 * 1, true);
            return r0 === 0 ? null : r2;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}

const ResMgrFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_resmgr_free(ptr >>> 0, 1));
/**
* 资源管理器
*/
export class ResMgr {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResMgrFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_resmgr_free(ptr, 0);
    }
    /**
    * 创建资源管理器的实例
    * @param {number} total_capacity
    */
    constructor(total_capacity) {
        const ret = wasm.resmgr_new(total_capacity);
        this.__wbg_ptr = ret >>> 0;
        ResMgrFinalization.register(this, this.__wbg_ptr, this);
        return this;
    }
    /**
    * 整理方法， 将无人使用的资源放入到LruCache， 清理过时的资源
    * 就是LruMgr有总内存上限， 按权重分给其下的LRU。 如果有LRU有空闲， 则会减少其max_size, 按权重提高那些满的LRU的max_size
    * @param {number} now
    */
    collect(now) {
        wasm.resmgr_collect(this.__wbg_ptr, now);
    }
}

const ResRefFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_resref_free(ptr >>> 0, 1));
/**
* 资源
*/
export class ResRef {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(ResRef.prototype);
        obj.__wbg_ptr = ptr;
        ResRefFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        ResRefFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_resref_free(ptr, 0);
    }
    /**
    * @returns {any}
    */
    link() {
        const ret = wasm.resref_link(this.__wbg_ptr);
        return takeObject(ret);
    }
}

const TabBufferFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tabbuffer_free(ptr >>> 0, 1));
/**
*/
export class TabBuffer {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TabBuffer.prototype);
        obj.__wbg_ptr = ptr;
        TabBufferFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TabBufferFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tabbuffer_free(ptr, 0);
    }
    /**
    * @returns {boolean}
    */
    next() {
        const ret = wasm.tabbuffer_next(this.__wbg_ptr);
        return ret !== 0;
    }
    /**
    * @returns {boolean}
    */
    next_tab() {
        const ret = wasm.tabbuffer_next_tab(this.__wbg_ptr);
        return ret !== 0;
    }
}

const TextInfosFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_textinfos_free(ptr >>> 0, 1));
/**
*/
export class TextInfos {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TextInfosFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_textinfos_free(ptr, 0);
    }
}

const TextureResFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_textureres_free(ptr >>> 0, 1));
/**
* 资源包装
*/
export class TextureRes {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TextureRes.prototype);
        obj.__wbg_ptr = ptr;
        TextureResFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TextureResFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_textureres_free(ptr, 0);
    }
    /**
    * @param {number} res
    * @returns {TextureRes}
    */
    static new(res) {
        const ret = wasm.textureres_new(res);
        return TextureRes.__wrap(ret);
    }
    /**
    * 创建一个资源， 如果资源已经存在，则会修改资源的配置
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} min_capacity
    * @param {number} max_capacity
    * @param {number} time_out
    */
    static register_to_resmgr(mgr, ty, min_capacity, max_capacity, time_out) {
        _assertClass(mgr, ResMgr);
        wasm.textureres_register_to_resmgr(mgr.__wbg_ptr, ty, min_capacity, max_capacity, time_out);
    }
    /**
    * 创建一个资源， 如果资源已经存在，旧的资源将被覆盖
    * 如果创建的资源类型未注册，将崩溃
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} key
    * @param {number} cost
    * @returns {NativeResRef}
    */
    create_res(mgr, ty, key, cost) {
        const ptr = this.__destroy_into_raw();
        _assertClass(mgr, ResMgr);
        const ret = wasm.textureres_create_res(ptr, mgr.__wbg_ptr, ty, key, cost);
        return NativeResRef.__wrap(ret);
    }
    /**
    * 获取资源
    * @param {ResMgr} mgr
    * @param {number} ty
    * @param {number} key
    * @returns {NativeResRef | undefined}
    */
    static get_res(mgr, ty, key) {
        _assertClass(mgr, ResMgr);
        const ret = wasm.textureres_get_res(mgr.__wbg_ptr, ty, key);
        return ret === 0 ? null : NativeResRef.__wrap(ret);
    }
}

const TileMapFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tilemap_free(ptr >>> 0, 1));
/**
*/
export class TileMap {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TileMap.prototype);
        obj.__wbg_ptr = ptr;
        TileMapFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TileMapFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tilemap_free(ptr, 0);
    }
    /**
    * @param {number} width
    * @param {number} height
    * @returns {TileMap}
    */
    static new(width, height) {
        const ret = wasm.tilemap_new(width, height);
        return TileMap.__wrap(ret);
    }
    /**
    * @param {number} index
    * @param {TileFlagType} flag_type
    * @param {number} value
    * @returns {number}
    */
    set_node_flag(index, flag_type, value) {
        const ret = wasm.tilemap_set_node_flag(this.__wbg_ptr, index, flag_type, value);
        return ret;
    }
    /**
    * @param {number} index
    * @param {TileFlagType} flag_type
    * @returns {number}
    */
    get_node_flag(index, flag_type) {
        const ret = wasm.tilemap_get_node_flag(this.__wbg_ptr, index, flag_type);
        return ret;
    }
    /**
    * @param {number} x1
    * @param {number} y1
    * @param {number} x2
    * @param {number} y2
    * @param {number} value
    */
    set_range_flag(x1, y1, x2, y2, value) {
        wasm.tilemap_set_range_flag(this.__wbg_ptr, x1, y1, x2, y2, value);
    }
    /**
    * @param {number} index
    * @param {number} count
    * @param {number} spacing
    * @param {Direction} d
    * @param {number} flag
    * @returns {any}
    */
    find_round(index, count, spacing, d, flag) {
        const ret = wasm.tilemap_find_round(this.__wbg_ptr, index, count, spacing, d, flag);
        return takeObject(ret);
    }
    /**
    * @param {number} index
    * @param {number} count
    * @param {number} spacing
    * @param {Direction} d
    * @param {number} flag
    * @param {number} target_x
    * @param {number} target_y
    * @returns {any}
    */
    find_round_and_sort_by_dist(index, count, spacing, d, flag, target_x, target_y) {
        const ret = wasm.tilemap_find_round_and_sort_by_dist(this.__wbg_ptr, index, count, spacing, d, flag, target_x, target_y);
        return takeObject(ret);
    }
    /**
    * @param {number} start_x
    * @param {number} start_y
    * @param {number} end_x
    * @param {number} end_y
    * @param {number} center_flag
    * @param {number} side_flag
    * @returns {any}
    */
    test_line(start_x, start_y, end_x, end_y, center_flag, side_flag) {
        const ret = wasm.tilemap_test_line(this.__wbg_ptr, start_x, start_y, end_x, end_y, center_flag, side_flag);
        return takeObject(ret);
    }
}

const TileMapTreeFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_tilemaptree_free(ptr >>> 0, 1));
/**
*/
export class TileMapTree {

    static __wrap(ptr) {
        ptr = ptr >>> 0;
        const obj = Object.create(TileMapTree.prototype);
        obj.__wbg_ptr = ptr;
        TileMapTreeFinalization.register(obj, obj.__wbg_ptr, obj);
        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TileMapTreeFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_tilemaptree_free(ptr, 0);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @param {number} width
    * @param {number} height
    * @returns {TileMapTree}
    */
    static new(min_x, min_y, max_x, max_y, width, height) {
        const ret = wasm.tilemaptree_new(min_x, min_y, max_x, max_y, width, height);
        return TileMapTree.__wrap(ret);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {number}
    */
    add(min_x, min_y, max_x, max_y) {
        const ret = wasm.tilemaptree_add(this.__wbg_ptr, min_x, min_y, max_x, max_y);
        return ret;
    }
    /**
    * @param {number} id
    */
    remove(id) {
        wasm.tilemaptree_remove(this.__wbg_ptr, id);
    }
    /**
    * @param {number} id
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    */
    update(id, min_x, min_y, max_x, max_y) {
        wasm.tilemaptree_update(this.__wbg_ptr, id, min_x, min_y, max_x, max_y);
    }
    /**
    * @param {number} min_x
    * @param {number} min_y
    * @param {number} max_x
    * @param {number} max_y
    * @returns {Uint32Array}
    */
    query(min_x, min_y, max_x, max_y) {
        try {
            const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
            wasm.tilemaptree_query(retptr, this.__wbg_ptr, min_x, min_y, max_x, max_y);
            var r0 = getDataViewMemory0().getInt32(retptr + 4 * 0, true);
            var r1 = getDataViewMemory0().getInt32(retptr + 4 * 1, true);
            var v1 = getArrayU32FromWasm0(r0, r1).slice();
            wasm.__wbindgen_free(r0, r1 * 4, 4);
            return v1;
        } finally {
            wasm.__wbindgen_add_to_stack_pointer(16);
        }
    }
}

const TypeIdFinalization = (typeof FinalizationRegistry === 'undefined')
    ? { register: () => {}, unregister: () => {} }
    : new FinalizationRegistry(ptr => wasm.__wbg_typeid_free(ptr >>> 0, 1));
/**
*/
export class TypeId {

    __destroy_into_raw() {
        const ptr = this.__wbg_ptr;
        this.__wbg_ptr = 0;
        TypeIdFinalization.unregister(this);
        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_typeid_free(ptr, 0);
    }
    /**
    * @returns {number}
    */
    get 0() {
        const ret = wasm.__wbg_get_typeid_0(this.__wbg_ptr);
        return ret >>> 0;
    }
    /**
    * @param {number} arg0
    */
    set 0(arg0) {
        wasm.__wbg_set_typeid_0(this.__wbg_ptr, arg0);
    }
}

async function __wbg_load(module, imports) {
    if (typeof Response === 'function' && module instanceof Response) {
        if (typeof WebAssembly.instantiateStreaming === 'function') {
            try {
                return await WebAssembly.instantiateStreaming(module, imports);

            } catch (e) {
                if (module.headers.get('Content-Type') != 'application/wasm') {
                    console.warn("`WebAssembly.instantiateStreaming` failed because your server does not serve wasm with `application/wasm` MIME type. Falling back to `WebAssembly.instantiate` which is slower. Original error:\n", e);

                } else {
                    throw e;
                }
            }
        }

        const bytes = await module.arrayBuffer();
        return await WebAssembly.instantiate(bytes, imports);

    } else {
        const instance = await WebAssembly.instantiate(module, imports);

        if (instance instanceof WebAssembly.Instance) {
            return { instance, module };

        } else {
            return instance;
        }
    }
}

function __wbg_get_imports() {
    const imports = {};
    imports.wbg = {};
    imports.wbg.__wbg_new_abda76e883ba8a5f = function() {
        const ret = new Error();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_stack_658279fe44541cf6 = function(arg0, arg1) {
        const ret = getObject(arg1).stack;
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_error_f851667af71bcfc6 = function(arg0, arg1) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            console.error(getStringFromWasm0(arg0, arg1));
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbindgen_object_drop_ref = function(arg0) {
        takeObject(arg0);
    };
    imports.wbg.__wbg_createBuffer_9571c039ba6696c6 = function(arg0) {
        const ret = getObject(arg0).createBuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_bufferData_fc33089cf05a6c5a = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferData(arg1 >>> 0, arg2, arg3 >>> 0);
    };
    imports.wbg.__wbg_createVertexArrayOES_25dbc05f13ec06fe = function(arg0) {
        const ret = getObject(arg0).createVertexArrayOES();
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_json_parse = function(arg0, arg1) {
        const ret = JSON.parse(getStringFromWasm0(arg0, arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_number_get = function(arg0, arg1) {
        const obj = getObject(arg1);
        const ret = typeof(obj) === 'number' ? obj : undefined;
        getDataViewMemory0().setFloat64(arg0 + 8 * 1, isLikeNone(ret) ? 0 : ret, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, !isLikeNone(ret), true);
    };
    imports.wbg.__wbg_createRenderbuffer_620bdfb7867926e8 = function(arg0) {
        const ret = getObject(arg0).createRenderbuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_bindRenderbuffer_297ae310683dc32b = function(arg0, arg1, arg2) {
        getObject(arg0).bindRenderbuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_renderbufferStorage_8c3882aa73deada9 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).renderbufferStorage(arg1 >>> 0, arg2 >>> 0, arg3, arg4);
    };
    imports.wbg.__wbindgen_number_new = function(arg0) {
        const ret = arg0;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_document_8554450897a855b9 = function(arg0) {
        const ret = getObject(arg0).document;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createElement_5921e9eb06b9ec89 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).createElement(getStringFromWasm0(arg1, arg2));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_instanceof_HtmlCanvasElement_1a96a01603ec2d8b = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_getContext_69ec873410cbba3c = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).getContext(getStringFromWasm0(arg1, arg2));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_instanceof_CanvasRenderingContext2d_a0c4f0da6392b8ca = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbindgen_memory = function() {
        const ret = wasm.memory;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_buffer_b7b08af79b0b0974 = function(arg0) {
        const ret = getObject(arg0).buffer;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_874df3e29cb555f9 = function(arg0, arg1, arg2) {
        const ret = new Uint32Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_5d12bfb7e37fc427 = function(arg0) {
        const ret = new Uint32Array(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_compressedTexImage2D_dcbfdcf1f6e866da = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
        getObject(arg0).compressedTexImage2D(arg1 >>> 0, arg2, arg3 >>> 0, arg4, arg5, arg6, getObject(arg7));
    };
    imports.wbg.__wbindgen_object_clone_ref = function(arg0) {
        const ret = getObject(arg0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_width_ac5901de11cd9abc = function(arg0) {
        const ret = getObject(arg0).width;
        return ret;
    };
    imports.wbg.__wbg_height_bf0ba2fba351acb3 = function(arg0) {
        const ret = getObject(arg0).height;
        return ret;
    };
    imports.wbg.__wbg_measureText_bec0a282a6e81f32 = function(arg0, arg1, arg2, arg3) {
        const ret = measureText(getObject(arg0), arg1 >>> 0, arg2 >>> 0, arg3 >>> 0);
        return ret;
    };
    imports.wbg.__wbg_loadImage_4b7979a78bede46e = function(arg0, arg1) {
        loadImage(arg0 >>> 0, getObject(arg1));
    };
    imports.wbg.__wbg_setSdfSuccessCallback_80ee9eb424d644fc = function(arg0) {
        setSdfSuccessCallback(getObject(arg0));
    };
    imports.wbg.__wbg_length_8339fcf5d8ecd12e = function(arg0) {
        const ret = getObject(arg0).length;
        return ret;
    };
    imports.wbg.__wbg_new_ea1883e1e5e86686 = function(arg0) {
        const ret = new Uint8Array(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_d1e79e2388520f18 = function(arg0, arg1, arg2) {
        getObject(arg0).set(getObject(arg1), arg2 >>> 0);
    };
    imports.wbg.__wbg_call_c6fe275aaa60da79 = function() { return handleError(function (arg0, arg1, arg2, arg3) {
        const ret = getObject(arg0).call(getObject(arg1), getObject(arg2), getObject(arg3));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_drawSdf_4468ea090388c957 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
        drawSdf(arg0 >>> 0, arg1 >>> 0, takeObject(arg2), takeObject(arg3), arg4 >>> 0, arg5 >>> 0, arg6 >>> 0, arg7 >>> 0);
    };
    imports.wbg.__wbg_fillBackGround_7b4321e977704329 = function(arg0, arg1, arg2, arg3) {
        fillBackGround(getObject(arg0), getObject(arg1), arg2 >>> 0, arg3 >>> 0);
    };
    imports.wbg.__wbg_setFont_6024d4aa0f5ad2fb = function(arg0, arg1, arg2, arg3, arg4) {
        setFont(getObject(arg0), arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4);
    };
    imports.wbg.__wbg_drawChar_c29baf1d076f07a2 = function(arg0, arg1, arg2, arg3) {
        drawChar(getObject(arg0), arg1 >>> 0, arg2 >>> 0, arg3 >>> 0);
    };
    imports.wbg.__wbg_drawCharWithStroke_b637057c25ed51e5 = function(arg0, arg1, arg2, arg3) {
        drawCharWithStroke(getObject(arg0), arg1 >>> 0, arg2 >>> 0, arg3 >>> 0);
    };
    imports.wbg.__wbg_now_b7a162010a9e75b4 = function() {
        const ret = Date.now();
        return ret;
    };
    imports.wbg.__wbg_resolve_570458cb99d56a43 = function(arg0) {
        const ret = Promise.resolve(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_then_95e6edc0f89b73b1 = function(arg0, arg1) {
        const ret = getObject(arg0).then(getObject(arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_valueOf_c759749a331da0c0 = function(arg0) {
        const ret = getObject(arg0).valueOf();
        return ret;
    };
    imports.wbg.__wbg_deleteBuffer_898974b9db136e43 = function(arg0, arg1) {
        getObject(arg0).deleteBuffer(getObject(arg1));
    };
    imports.wbg.__wbg_deleteVertexArrayOES_269afb722fe7be16 = function(arg0, arg1) {
        getObject(arg0).deleteVertexArrayOES(getObject(arg1));
    };
    imports.wbg.__wbg_bindVertexArrayOES_7003189657205a5b = function(arg0, arg1) {
        getObject(arg0).bindVertexArrayOES(getObject(arg1));
    };
    imports.wbg.__wbg_createProgram_2c3a8969b5a76988 = function(arg0) {
        const ret = getObject(arg0).createProgram();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_linkProgram_1f18bca817bb6edb = function(arg0, arg1) {
        getObject(arg0).linkProgram(getObject(arg1));
    };
    imports.wbg.__wbg_valueOf_563b3487b1b116aa = function(arg0) {
        const ret = getObject(arg0).valueOf();
        return ret;
    };
    imports.wbg.__wbg_bindAttribLocation_0018ec2a523f139f = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).bindAttribLocation(getObject(arg1), arg2 >>> 0, getStringFromWasm0(arg3, arg4));
    };
    imports.wbg.__wbg_getProgramInfoLog_22296c36addf7a70 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getProgramInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_getActiveUniform_159396aad975574f = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getActiveUniform(getObject(arg1), arg2 >>> 0);
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_getUniformLocation_9cd213015cf8f29f = function(arg0, arg1, arg2, arg3) {
        const ret = getObject(arg0).getUniformLocation(getObject(arg1), getStringFromWasm0(arg2, arg3));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_type_93c1f6a48207f1d3 = function(arg0) {
        const ret = getObject(arg0).type;
        return ret;
    };
    imports.wbg.__wbg_size_0926a87619f2bfe7 = function(arg0) {
        const ret = getObject(arg0).size;
        return ret;
    };
    imports.wbg.__wbg_createShader_af087106532661d9 = function(arg0, arg1) {
        const ret = getObject(arg0).createShader(arg1 >>> 0);
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_shaderSource_d447b31057e4f64c = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).shaderSource(getObject(arg1), getStringFromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_compileShader_043cc8b99c2efc21 = function(arg0, arg1) {
        getObject(arg0).compileShader(getObject(arg1));
    };
    imports.wbg.__wbg_getShaderInfoLog_935361c52a919c15 = function(arg0, arg1, arg2) {
        const ret = getObject(arg1).getShaderInfoLog(getObject(arg2));
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_deleteFramebuffer_d632dfba2c1f5c75 = function(arg0, arg1) {
        getObject(arg0).deleteFramebuffer(getObject(arg1));
    };
    imports.wbg.__wbg_framebufferRenderbuffer_fee6ceb2330389b7 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).framebufferRenderbuffer(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4));
    };
    imports.wbg.__wbg_deleteRenderbuffer_ccae7372581ae424 = function(arg0, arg1) {
        getObject(arg0).deleteRenderbuffer(getObject(arg1));
    };
    imports.wbg.__wbg_texImage2D_512f682410bd5a5d = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        getObject(arg0).texImage2D(arg1 >>> 0, arg2, arg3, arg4 >>> 0, arg5 >>> 0, getObject(arg6));
    }, arguments) };
    imports.wbg.__wbg_texImage2D_cfdc84dfaa9b3005 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10) {
        getObject(arg0).texImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, arg9 === 0 ? null : getArrayF32FromWasm0(arg9, arg10));
    }, arguments) };
    imports.wbg.__wbg_generateMipmap_52c223b74b4f16a3 = function(arg0, arg1) {
        getObject(arg0).generateMipmap(arg1 >>> 0);
    };
    imports.wbg.__wbg_compressedTexSubImage2D_5ec81a1eb714a926 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10) {
        getObject(arg0).compressedTexSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, arg9 === 0 ? null : getArrayF32FromWasm0(arg9, arg10));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_7fbe8e15330c9447 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5 >>> 0, arg6 >>> 0, getObject(arg7));
    }, arguments) };
    imports.wbg.__wbg_texSubImage2D_c325194f1eb7ce50 = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10) {
        getObject(arg0).texSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, arg9 === 0 ? null : getArrayU8FromWasm0(arg9, arg10));
    }, arguments) };
    imports.wbg.__wbg_copyTexSubImage2D_8f6644e7df89a307 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) {
        getObject(arg0).copyTexSubImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
    };
    imports.wbg.__wbg_polygonOffset_6d8d69a8d60e5b82 = function(arg0, arg1, arg2) {
        getObject(arg0).polygonOffset(arg1, arg2);
    };
    imports.wbg.__wbg_depthFunc_5398fbc3f56db827 = function(arg0, arg1) {
        getObject(arg0).depthFunc(arg1 >>> 0);
    };
    imports.wbg.__wbg_blendColor_c876d94aa784bef7 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).blendColor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_stencilOp_2418383669ca9228 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).stencilOp(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0);
    };
    imports.wbg.__wbg_stencilFunc_0e2a6d25bdcb678e = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).stencilFunc(arg1 >>> 0, arg2, arg3 >>> 0);
    };
    imports.wbg.__wbg_blendEquationSeparate_95241ffd0f6ab09e = function(arg0, arg1, arg2) {
        getObject(arg0).blendEquationSeparate(arg1 >>> 0, arg2 >>> 0);
    };
    imports.wbg.__wbg_blendFuncSeparate_2b607032f14b9381 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).blendFuncSeparate(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, arg4 >>> 0);
    };
    imports.wbg.__wbg_cullFace_ccad99c645b704eb = function(arg0, arg1) {
        getObject(arg0).cullFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_frontFace_358bf8c6c5159d54 = function(arg0, arg1) {
        getObject(arg0).frontFace(arg1 >>> 0);
    };
    imports.wbg.__wbg_clear_780c4e5384fe3fc6 = function(arg0, arg1) {
        getObject(arg0).clear(arg1 >>> 0);
    };
    imports.wbg.__wbg_useProgram_d4616618ac6d0652 = function(arg0, arg1) {
        getObject(arg0).useProgram(getObject(arg1));
    };
    imports.wbg.__wbg_drawArrays_532f4e0a4547dd1f = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).drawArrays(arg1 >>> 0, arg2, arg3);
    };
    imports.wbg.__wbg_drawElements_5b776409d809de04 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).drawElements(arg1 >>> 0, arg2, arg3 >>> 0, arg4);
    };
    imports.wbg.__wbg_uniform1fv_218fa6dd6940465c = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform1fv(getObject(arg1), getArrayF32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform2fv_b73144e507d90a92 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform2fv(getObject(arg1), getArrayF32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform3fv_5df1d945c0bbfe20 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform3fv(getObject(arg1), getArrayF32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform4fv_d87e4ea9ef6cf6de = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform4fv(getObject(arg1), getArrayF32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform1iv_ff178f54a0f1d06a = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform1iv(getObject(arg1), getArrayI32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform2iv_27f3fc3aefa41fa7 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform2iv(getObject(arg1), getArrayI32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform3iv_03be54fcc4468fc4 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform3iv(getObject(arg1), getArrayI32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniform4iv_965df9fa4c8ab47e = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform4iv(getObject(arg1), getArrayI32FromWasm0(arg2, arg3));
    };
    imports.wbg.__wbg_uniformMatrix2fv_8646addaa18ba00b = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).uniformMatrix2fv(getObject(arg1), arg2 !== 0, getArrayF32FromWasm0(arg3, arg4));
    };
    imports.wbg.__wbg_uniformMatrix3fv_917f07d03e8b1db5 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).uniformMatrix3fv(getObject(arg1), arg2 !== 0, getArrayF32FromWasm0(arg3, arg4));
    };
    imports.wbg.__wbg_uniformMatrix4fv_46c1f9033bbb1a5e = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).uniformMatrix4fv(getObject(arg1), arg2 !== 0, getArrayF32FromWasm0(arg3, arg4));
    };
    imports.wbg.__wbg_uniform4i_12d9b661afda856c = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).uniform4i(getObject(arg1), arg2, arg3, arg4, arg5);
    };
    imports.wbg.__wbg_uniform3i_990ccb7abc498f7d = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).uniform3i(getObject(arg1), arg2, arg3, arg4);
    };
    imports.wbg.__wbg_uniform2i_1dd84915eae632e7 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform2i(getObject(arg1), arg2, arg3);
    };
    imports.wbg.__wbg_uniform4f_f9a7809965964840 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).uniform4f(getObject(arg1), arg2, arg3, arg4, arg5);
    };
    imports.wbg.__wbg_uniform3f_07c0ab1171cdd550 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).uniform3f(getObject(arg1), arg2, arg3, arg4);
    };
    imports.wbg.__wbg_uniform2f_95babaad453bac89 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).uniform2f(getObject(arg1), arg2, arg3);
    };
    imports.wbg.__wbg_uniform1f_509b4ba100d75456 = function(arg0, arg1, arg2) {
        getObject(arg0).uniform1f(getObject(arg1), arg2);
    };
    imports.wbg.__wbindgen_is_null = function(arg0) {
        const ret = getObject(arg0) === null;
        return ret;
    };
    imports.wbg.__wbindgen_is_undefined = function(arg0) {
        const ret = getObject(arg0) === undefined;
        return ret;
    };
    imports.wbg.__wbg_self_3093d5d1f7bcb682 = function() { return handleError(function () {
        const ret = self.self;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_window_3bcfc4d31bc012f8 = function() { return handleError(function () {
        const ret = window.window;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_globalThis_86b222e13bdf32ed = function() { return handleError(function () {
        const ret = globalThis.globalThis;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_global_e5a3fe56f8be9485 = function() { return handleError(function () {
        const ret = global.global;
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_newnoargs_76313bd6ff35d0f2 = function(arg0, arg1) {
        const ret = new Function(getStringFromWasm0(arg0, arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_call_1084a111329e68ce = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).call(getObject(arg1));
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_newwithbyteoffsetandlength_8a2cb9ca96b27ec9 = function(arg0, arg1, arg2) {
        const ret = new Uint8Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_bd3d5191e8925067 = function(arg0, arg1, arg2) {
        const ret = new Uint16Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_newwithbyteoffsetandlength_a69c63d7671a5dbf = function(arg0, arg1, arg2) {
        const ret = new Float32Array(getObject(arg0), arg1 >>> 0, arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_u128 = function(arg0, arg1) {
        const ret = BigInt.asUintN(64, arg0) << BigInt(64) | BigInt.asUintN(64, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_i128 = function(arg0, arg1) {
        const ret = arg0 << BigInt(64) | BigInt.asUintN(64, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_8608a2b51a5f6737 = function() {
        const ret = new Map();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_new_a220cf903aa02ca2 = function() {
        const ret = new Array();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_push_37c89022f34c01ca = function(arg0, arg1) {
        const ret = getObject(arg0).push(getObject(arg1));
        return ret;
    };
    imports.wbg.__wbg_new_525245e2b9901204 = function() {
        const ret = new Object();
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_set_49185437f0ab06f8 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).set(getObject(arg1), getObject(arg2));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_u64 = function(arg0) {
        const ret = BigInt.asUintN(64, arg0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_bigint_from_i64 = function(arg0) {
        const ret = arg0;
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_bonbuffer_fb7dff181fefd7cb = function(arg0, arg1) {
        bon_buffer(getArrayU8FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbindgen_is_string = function(arg0) {
        const ret = typeof(getObject(arg0)) === 'string';
        return ret;
    };
    imports.wbg.__wbindgen_string_get = function(arg0, arg1) {
        const obj = getObject(arg1);
        const ret = typeof(obj) === 'string' ? obj : undefined;
        var ptr1 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        var len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_new_0d215095f6a3600f = function(arg0) {
        const ret = new Set(getObject(arg0));
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_add_653baf3821a15934 = function(arg0, arg1) {
        const ret = getObject(arg0).add(getObject(arg1));
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_string_new = function(arg0, arg1) {
        const ret = getStringFromWasm0(arg0, arg1);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_roundresult_61928002a27bb0f9 = function(arg0, arg1) {
        round_result(getArrayI32FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_pathresult_90e64783aeee82bd = function(arg0, arg1) {
        path_result(getArrayI32FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbindgen_copy_to_typed_array = function(arg0, arg1, arg2) {
        new Uint8Array(getObject(arg2).buffer, getObject(arg2).byteOffset, getObject(arg2).byteLength).set(getArrayU8FromWasm0(arg0, arg1));
    };
    imports.wbg.__wbg_writeLog_86af01168d16c151 = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        let deferred0_0;
        let deferred0_1;
        try {
            deferred0_0 = arg0;
            deferred0_1 = arg1;
            let v1;
            if (arg3 !== 0) {
                v1 = getStringFromWasm0(arg3, arg4).slice();
                wasm.__wbindgen_free(arg3, arg4 * 1, 1);
            }
            writeLog(getStringFromWasm0(arg0, arg1), arg2, v1, arg5 === 0 ? null : arg6 >>> 0);
        } finally {
            wasm.__wbindgen_free(deferred0_0, deferred0_1, 1);
        }
    };
    imports.wbg.__wbg_destroyres_4c97e13412d35dfe = function(arg0) {
        destroy_res(getObject(arg0));
    };
    imports.wbg.__wbg_set_841ac57cff3d672b = function(arg0, arg1, arg2) {
        getObject(arg0)[takeObject(arg1)] = takeObject(arg2);
    };
    imports.wbg.__wbindgen_throw = function(arg0, arg1) {
		let str = getStringFromWasm0(arg0, arg1);
		window._$pi?._wasmThrow?.(str);
        throw new Error(str);
    };
    imports.wbg.__wbindgen_debug_string = function(arg0, arg1) {
        const ret = debugString(getObject(arg1));
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_instanceof_Window_5012736c80a01584 = function(arg0) {
        let result;
        try {
            result = true;
        } catch (_) {
            result = false;
        }
        const ret = result;
        return ret;
    };
    imports.wbg.__wbg_now_a69647afb1f66247 = function(arg0) {
        const ret = getObject(arg0).now();
        return ret;
    };
    imports.wbg.__wbg_name_64fd60cd42fa02e9 = function(arg0, arg1) {
        const ret = getObject(arg1).name;
        const ptr1 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
        const len1 = WASM_VECTOR_LEN;
        getDataViewMemory0().setInt32(arg0 + 4 * 1, len1, true);
        getDataViewMemory0().setInt32(arg0 + 4 * 0, ptr1, true);
    };
    imports.wbg.__wbg_bufferData_0db2a74470353a96 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferData(arg1 >>> 0, getObject(arg2), arg3 >>> 0);
    };
    imports.wbg.__wbg_bufferSubData_944883045753ee61 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).bufferSubData(arg1 >>> 0, arg2, getObject(arg3));
    };
    imports.wbg.__wbg_texImage2D_393ba0d690372bab = function() { return handleError(function (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10) {
        getObject(arg0).texImage2D(arg1 >>> 0, arg2, arg3, arg4, arg5, arg6, arg7 >>> 0, arg8 >>> 0, arg9 === 0 ? null : getArrayU8FromWasm0(arg9, arg10));
    }, arguments) };
    imports.wbg.__wbg_activeTexture_b967ed47a8083daa = function(arg0, arg1) {
        getObject(arg0).activeTexture(arg1 >>> 0);
    };
    imports.wbg.__wbg_attachShader_2b5810fc1d23ebe7 = function(arg0, arg1, arg2) {
        getObject(arg0).attachShader(getObject(arg1), getObject(arg2));
    };
    imports.wbg.__wbg_bindBuffer_1f581c747176e7d7 = function(arg0, arg1, arg2) {
        getObject(arg0).bindBuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindFramebuffer_8cba9964befd2a6d = function(arg0, arg1, arg2) {
        getObject(arg0).bindFramebuffer(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_bindTexture_bffa89324927e23a = function(arg0, arg1, arg2) {
        getObject(arg0).bindTexture(arg1 >>> 0, getObject(arg2));
    };
    imports.wbg.__wbg_clearColor_ac713fa6931cef3c = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).clearColor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_clearDepth_92f7c7d02e50df24 = function(arg0, arg1) {
        getObject(arg0).clearDepth(arg1);
    };
    imports.wbg.__wbg_clearStencil_78b0b3c82001b542 = function(arg0, arg1) {
        getObject(arg0).clearStencil(arg1);
    };
    imports.wbg.__wbg_createFramebuffer_20f79ec189ef2060 = function(arg0) {
        const ret = getObject(arg0).createFramebuffer();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_createTexture_e49c36c5f31925a3 = function(arg0) {
        const ret = getObject(arg0).createTexture();
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_deleteProgram_5f938b0667141206 = function(arg0, arg1) {
        getObject(arg0).deleteProgram(getObject(arg1));
    };
    imports.wbg.__wbg_deleteTexture_558c751a66bd2f16 = function(arg0, arg1) {
        getObject(arg0).deleteTexture(getObject(arg1));
    };
    imports.wbg.__wbg_depthMask_9b58af067c6393e9 = function(arg0, arg1) {
        getObject(arg0).depthMask(arg1 !== 0);
    };
    imports.wbg.__wbg_disable_d73e59fee5b5e973 = function(arg0, arg1) {
        getObject(arg0).disable(arg1 >>> 0);
    };
    imports.wbg.__wbg_disableVertexAttribArray_b9d8ae826c70526f = function(arg0, arg1) {
        getObject(arg0).disableVertexAttribArray(arg1 >>> 0);
    };
    imports.wbg.__wbg_enable_68b3fa03a633259a = function(arg0, arg1) {
        getObject(arg0).enable(arg1 >>> 0);
    };
    imports.wbg.__wbg_enableVertexAttribArray_52c23a516be565c0 = function(arg0, arg1) {
        getObject(arg0).enableVertexAttribArray(arg1 >>> 0);
    };
    imports.wbg.__wbg_framebufferTexture2D_ae81a33228e46de6 = function(arg0, arg1, arg2, arg3, arg4, arg5) {
        getObject(arg0).framebufferTexture2D(arg1 >>> 0, arg2 >>> 0, arg3 >>> 0, getObject(arg4), arg5);
    };
    imports.wbg.__wbg_getExtension_39f01d7a720d3a67 = function() { return handleError(function (arg0, arg1, arg2) {
        const ret = getObject(arg0).getExtension(getStringFromWasm0(arg1, arg2));
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_getParameter_8df84a84197f2148 = function() { return handleError(function (arg0, arg1) {
        const ret = getObject(arg0).getParameter(arg1 >>> 0);
        return addHeapObject(ret);
    }, arguments) };
    imports.wbg.__wbg_getProgramParameter_ab2954ca517d8589 = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getProgramParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_getShaderParameter_cedb1ec0d8052eff = function(arg0, arg1, arg2) {
        const ret = getObject(arg0).getShaderParameter(getObject(arg1), arg2 >>> 0);
        return addHeapObject(ret);
    };
    imports.wbg.__wbg_pixelStorei_2498331e094ff305 = function(arg0, arg1, arg2) {
        getObject(arg0).pixelStorei(arg1 >>> 0, arg2);
    };
    imports.wbg.__wbg_scissor_d06b14c4966727fa = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).scissor(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_texParameteri_83ad7181b62f4997 = function(arg0, arg1, arg2, arg3) {
        getObject(arg0).texParameteri(arg1 >>> 0, arg2 >>> 0, arg3);
    };
    imports.wbg.__wbg_uniform1i_7f6e60c975d21e0a = function(arg0, arg1, arg2) {
        getObject(arg0).uniform1i(getObject(arg1), arg2);
    };
    imports.wbg.__wbg_vertexAttribPointer_fcbfe42523d724ca = function(arg0, arg1, arg2, arg3, arg4, arg5, arg6) {
        getObject(arg0).vertexAttribPointer(arg1 >>> 0, arg2, arg3 >>> 0, arg4 !== 0, arg5, arg6);
    };
    imports.wbg.__wbg_viewport_efc09c09d4f3cc48 = function(arg0, arg1, arg2, arg3, arg4) {
        getObject(arg0).viewport(arg1, arg2, arg3, arg4);
    };
    imports.wbg.__wbg_performance_fa12dc8712926291 = function(arg0) {
        const ret = getObject(arg0).performance;
        return isLikeNone(ret) ? 0 : addHeapObject(ret);
    };
    imports.wbg.__wbg_debug_5a33c41aeac15ee6 = function(arg0) {
        console.debug(getObject(arg0));
    };
    imports.wbg.__wbg_error_09480e4aadca50ad = function(arg0) {
        console.error(getObject(arg0));
    };
    imports.wbg.__wbg_info_c261acb2deacd903 = function(arg0) {
        console.info(getObject(arg0));
    };
    imports.wbg.__wbg_log_b103404cc5920657 = function(arg0) {
        console.log(getObject(arg0));
    };
    imports.wbg.__wbg_warn_2b3adb99ce26c314 = function(arg0) {
        console.warn(getObject(arg0));
    };
    imports.wbg.__wbindgen_closure_wrapper2602 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 78, __wbg_adapter_38);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_closure_wrapper2608 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 78, __wbg_adapter_41);
        return addHeapObject(ret);
    };
    imports.wbg.__wbindgen_closure_wrapper2612 = function(arg0, arg1, arg2) {
        const ret = makeMutClosure(arg0, arg1, 78, __wbg_adapter_44);
        return addHeapObject(ret);
    };
    imports['./snippets/gui_web-fe567f277be011de/js/utils.js'] = __wbg_star0;

    return imports;
}

function __wbg_init_memory(imports, memory) {

}

function __wbg_finalize_init(instance, module) {
    wasm = instance.exports;
    __wbg_init.__wbindgen_wasm_module = module;
    cachedDataViewMemory0 = null;
    cachedFloat32ArrayMemory0 = null;
    cachedFloat64ArrayMemory0 = null;
    cachedInt32ArrayMemory0 = null;
    cachedUint32ArrayMemory0 = null;
    cachedUint8ArrayMemory0 = null;



    return wasm;
}

function initSync(module) {
    if (wasm !== undefined) return wasm;


    if (typeof module !== 'undefined' && Object.getPrototypeOf(module) === Object.prototype)
    ({module} = module)
    else
    console.warn('using deprecated parameters for `initSync()`; pass a single object instead')

    const imports = __wbg_get_imports();

    __wbg_init_memory(imports);

    if (!(module instanceof WebAssembly.Module)) {
        module = new WebAssembly.Module(module);
    }

    const instance = new WebAssembly.Instance(module, imports);

    return __wbg_finalize_init(instance, module);
}

async function __wbg_init(module_or_path) {
    if (wasm !== undefined) return wasm;


    if (typeof module_or_path !== 'undefined' && Object.getPrototypeOf(module_or_path) === Object.prototype)
    ({module_or_path} = module_or_path)
    else
    console.warn('using deprecated parameters for the initialization function; pass a single object instead')

    if (typeof module_or_path === 'undefined') {
        module_or_path = new URL('wasm_engine_bg.wasm', "");
    }
    const imports = __wbg_get_imports();

    if (typeof module_or_path === 'string' || (typeof Request === 'function' && module_or_path instanceof Request) || (typeof URL === 'function' && module_or_path instanceof URL)) {
        module_or_path = fetch(module_or_path);
    }

    __wbg_init_memory(imports);

    const r = await __wbg_load(await module_or_path, imports);

    __wbg_finalize_init(r.instance, r.module);
	if(module.postRun) {
		module.postRun();
	}

    return wasm;
}

export { initSync }
// 前后端适配
if(!globalThis._$cwd){
	Promise.resolve().then(() => {
		__wbg_init(module.wasmModule).then((r) => {
			window["_$wasm"] = r;
		});
	})
}

